//
//  CollectionViewCellAnunci.m
//  Manager
//
//  Created by Andreu Biosca on 19/1/18.
//  Copyright © 2018 Andreu Biosca. All rights reserved.
//

#import "CollectionViewCellItem.h"
#import "IncludesCompartits.h"

@implementation CollectionViewCellItem

- (instancetype)initWithFrame:(CGRect)rect
{
    
    self = [super initWithFrame:rect];
    
    if ([[NSProcessInfo processInfo] environment][@"executantEnModeTestUI"]) {
        // Executant en mode UI test per poder simular que polsem la primera cela del collection view d'ingredients
        self.isAccessibilityElement = YES;
    }
    
    int cellpadding = 25;
    
    float amplada = rect.size.width;
    
    self.amplada_definitiva = amplada-(cellpadding*2);
    
    float amplada_definitiva = self.amplada_definitiva;
    
    UIView *vistaCela = [[UIView alloc] initWithFrame:CGRectMake(cellpadding, cellpadding, amplada_definitiva, amplada_definitiva)];
    
    CALayer * l = [vistaCela layer];
    [l setMasksToBounds:YES];
    [l setCornerRadius:30];
    l.borderWidth = 0;
    
    // Foto:
    
    self.imgvFoto = [[UIImageView alloc] initWithFrame:CGRectMake(0, 0, 0, 0)];
    [vistaCela addSubview:self.imgvFoto];

    // Fons negre
    
    float alsada_fons_negre = amplada_definitiva/3;
    
    
    UIView *fonsNegre = [[UIView alloc] initWithFrame:CGRectMake(0, amplada_definitiva-alsada_fons_negre, amplada_definitiva, alsada_fons_negre)];
    fonsNegre.backgroundColor = UIColor.blackColor;
    fonsNegre.alpha = .7;
    [vistaCela addSubview:fonsNegre];
    
    // Labels:
    
    int padding_label_titol_lateral = 18;
    int padding_label_titol_superiorinferior = 2;
    
    self.label_titol = [[UILabel alloc]initWithFrame:CGRectMake(padding_label_titol_lateral,
                                                                fonsNegre.frame.origin.y+padding_label_titol_superiorinferior,
                                                                amplada_definitiva-(2*padding_label_titol_lateral),
                                                                alsada_fons_negre-(2*padding_label_titol_superiorinferior))];
    self.label_titol.numberOfLines = 2;
    self.label_titol.backgroundColor = [UIColor clearColor];
    
    self.label_titol.font = [UIFont systemFontOfSize: 15];
    self.label_titol.textColor = UIColor.whiteColor;
    self.label_titol.textAlignment = NSTextAlignmentCenter;
    [vistaCela addSubview:self.label_titol];
 
    [self addSubview:vistaCela];
    
    return self;
    
}

-(void)recalculaFoto:(UIImage*)foto
{
    
    float width = foto.size.width;
    float height = foto.size.height;
    
    float amplada_definitiva = self.amplada_definitiva;
    
    CGRect rectFoto;

    if(width == height)
    {
        rectFoto = CGRectMake(0, 0, amplada_definitiva, amplada_definitiva);
    }else{
        if(width>height)
        {
            float ratio = amplada_definitiva/height;
            rectFoto = CGRectMake((amplada_definitiva/2)-((width*ratio)/2), 0, width*ratio, height*ratio);
        }else{
            // height>width
            float ratio = amplada_definitiva/width;
            rectFoto = CGRectMake(0, (amplada_definitiva/2)-((height*ratio)/2), width*ratio, height*ratio);
        }
    }
    
    
    self.imgvFoto.frame = rectFoto;
    self.imgvFoto.image = foto;

    
}

@end
