//
//  IncludesCompartits.m
//  Snapplic
//
//  Created by Andreu Biosca on 02/11/2018.
//  Copyright © 2018 Grupo Globalia. All rights reserved.
//

#import "IncludesCompartits.h"

@implementation IncludesCompartits

+ (UIImage*)getResizedImage:(UIImage*)original_image iMaxWidth:(int)iMaxWidth iMaxHeight:(int)iMaxHeight
{
    
    UIImage *definitive_image = original_image;
    
    // resize to max_image_width_height x max_image_width_height:
    
    CGSize image_size = definitive_image.size;
    
    NSLog(@"🏖 [ORIGINAL] %i x %i",(int)image_size.width,(int)image_size.height);
    
    if((image_size.width > iMaxWidth) || (image_size.height > iMaxHeight)){
        
        definitive_image = [self imageWithImage:definitive_image
                               scaledToMaxWidth:iMaxWidth
                                      maxHeight:iMaxHeight];
        
    }
    
    image_size = definitive_image.size;
    
    NSLog(@"🏖 [DEFINITIVE] %i x %i",(int)image_size.width,(int)image_size.height);
    
    return definitive_image;
    
}

+(UIImage *)imageWithImage:(UIImage *)image scaledToMaxWidth:(CGFloat)width maxHeight:(CGFloat)height {
    
    CGFloat oldWidth = image.size.width;
    CGFloat oldHeight = image.size.height;
    
    CGFloat scaleFactor = (oldWidth > oldHeight) ? width / oldWidth : height / oldHeight;
    
    CGFloat newHeight = oldHeight * scaleFactor;
    CGFloat newWidth = oldWidth * scaleFactor;
    CGSize newSize = CGSizeMake(newWidth, newHeight);
    
    return [self imageWithImage:image scaledToSize:newSize];
    
}

+(UIImage *)imageWithImage:(UIImage *)image scaledToSize:(CGSize)size {
    
    UIGraphicsBeginImageContextWithOptions(size, NO, 1.0);
    
    [image drawInRect:CGRectMake(0, 0, size.width, size.height)];
    UIImage *newImage = UIGraphicsGetImageFromCurrentImageContext();
    UIGraphicsEndImageContext();
    
    return newImage;
    
}


+(NSMutableArray*)carregaPreferenciaArray:(NSString*)sPreferencia
{
    return [[NSUserDefaults standardUserDefaults] objectForKey:sPreferencia];
}

+(void)gravaPreferenciaArray:(NSString*)sPreferencia valor:(NSMutableArray*)valor
{
    [[NSUserDefaults standardUserDefaults] setObject:valor forKey:sPreferencia];
    [[NSUserDefaults standardUserDefaults] synchronize];
}

+(NSString*)converteixAMinusculaLaPrimeraLletra:(NSString*)paraula
{
    
    return [[[paraula substringToIndex:1] lowercaseString] stringByAppendingString:[paraula substringFromIndex:1]];
    
}

+(NSString*)retornaParaulaAmbAAl:(NSString*)genere numero:(NSString*)numero paraula:(NSString*)paraula
{
    
    if([genere isEqualToString:@"M"])
    {
        
        if([numero isEqualToString:@"S"])
        {
            
            NSString *sPrimeraLletra = [[paraula substringToIndex:1] lowercaseString];
            
            // treiem els accents
            NSData *dataPrimeraLletra = [sPrimeraLletra dataUsingEncoding:NSASCIIStringEncoding allowLossyConversion:YES];
            sPrimeraLletra = [[NSString alloc] initWithData:dataPrimeraLletra encoding:NSASCIIStringEncoding];

            bool bComensaAmbVocal = [sPrimeraLletra isEqualToString:@"a"] || [sPrimeraLletra isEqualToString:@"e"] ||
                                    [sPrimeraLletra isEqualToString:@"i"] || [sPrimeraLletra isEqualToString:@"o"] ||
                                    [sPrimeraLletra isEqualToString:@"u"];
            
            return bComensaAmbVocal ? [NSString stringWithFormat:@"a l'%@",[self converteixAMinusculaLaPrimeraLletra:paraula]] :
                                      [NSString stringWithFormat:@"al %@",[self converteixAMinusculaLaPrimeraLletra:paraula]];
            
        }else{
            
            // número P (plural)
            
            return [NSString stringWithFormat:@"als %@",[self converteixAMinusculaLaPrimeraLletra:paraula]];
            
        }
        
    }else{
        
        // gènere F
        
        if([numero isEqualToString:@"S"])
        {
            
            NSString *sPrimeraLletra = [[paraula substringToIndex:1] lowercaseString];
            
            // treiem els accents
            NSData *dataPrimeraLletra = [sPrimeraLletra dataUsingEncoding:NSASCIIStringEncoding allowLossyConversion:YES];
            sPrimeraLletra = [[NSString alloc] initWithData:dataPrimeraLletra encoding:NSASCIIStringEncoding];

            bool bComensaAmbVocal = [sPrimeraLletra isEqualToString:@"a"] || [sPrimeraLletra isEqualToString:@"e"] ||
                                    [sPrimeraLletra isEqualToString:@"i"] || [sPrimeraLletra isEqualToString:@"o"] ||
                                    [sPrimeraLletra isEqualToString:@"u"];
            
            return bComensaAmbVocal ? [NSString stringWithFormat:@"a l'%@",[self converteixAMinusculaLaPrimeraLletra:paraula]] :
                                        [NSString stringWithFormat:@"a la %@",[self converteixAMinusculaLaPrimeraLletra:paraula]];
            
        }else{
            
            // número P (plural)
            
            return [NSString stringWithFormat:@"a les %@",[self converteixAMinusculaLaPrimeraLletra:paraula]];
            
        }
        
    }
    
}


+(NSString*)retornaParaulaAmbArticle:(NSString*)genere numero:(NSString*)numero paraula:(NSString*)paraula
{
    
    if([genere isEqualToString:@"M"])
    {
        
        if([numero isEqualToString:@"S"])
        {
            
            NSString *sPrimeraLletra = [[paraula substringToIndex:1] lowercaseString];
            
            // treiem els accents
            NSData *dataPrimeraLletra = [sPrimeraLletra dataUsingEncoding:NSASCIIStringEncoding allowLossyConversion:YES];
            sPrimeraLletra = [[NSString alloc] initWithData:dataPrimeraLletra encoding:NSASCIIStringEncoding];

            bool bComensaAmbVocal = [sPrimeraLletra isEqualToString:@"a"] || [sPrimeraLletra isEqualToString:@"e"] ||
                                    [sPrimeraLletra isEqualToString:@"i"] || [sPrimeraLletra isEqualToString:@"o"] ||
                                    [sPrimeraLletra isEqualToString:@"u"];
            
            return bComensaAmbVocal ? [NSString stringWithFormat:@"l'%@",[self converteixAMinusculaLaPrimeraLletra:paraula]] :
                                      [NSString stringWithFormat:@"el %@",[self converteixAMinusculaLaPrimeraLletra:paraula]];
            
        }else{
            
            // número P (plural)
            
            return [NSString stringWithFormat:@"els %@",[self converteixAMinusculaLaPrimeraLletra:paraula]];
            
        }
        
    }else{
        
        // gènere F
        
        if([numero isEqualToString:@"S"])
        {
            
            NSString *sPrimeraLletra = [[paraula substringToIndex:1] lowercaseString];
            
            // treiem els accents
            NSData *dataPrimeraLletra = [sPrimeraLletra dataUsingEncoding:NSASCIIStringEncoding allowLossyConversion:YES];
            sPrimeraLletra = [[NSString alloc] initWithData:dataPrimeraLletra encoding:NSASCIIStringEncoding];

            bool bComensaAmbVocal = [sPrimeraLletra isEqualToString:@"a"] || [sPrimeraLletra isEqualToString:@"e"] ||
                                    [sPrimeraLletra isEqualToString:@"i"] || [sPrimeraLletra isEqualToString:@"o"] ||
                                    [sPrimeraLletra isEqualToString:@"u"];
            
            return bComensaAmbVocal ? [NSString stringWithFormat:@"l'%@",[self converteixAMinusculaLaPrimeraLletra:paraula]] :
                                        [NSString stringWithFormat:@"la %@",[self converteixAMinusculaLaPrimeraLletra:paraula]];
            
        }else{
            
            // número P (plural)
            
            return [NSString stringWithFormat:@"les %@",[self converteixAMinusculaLaPrimeraLletra:paraula]];
            
        }
        
    }
    
}

+(NSString*)retornaParaulaAmbPreposicio:(NSString*)paraula
{
    
    NSString *sPrimeraLletra = [[paraula substringToIndex:1] lowercaseString];
    
    // treiem els accents
    NSData *dataPrimeraLletra = [sPrimeraLletra dataUsingEncoding:NSASCIIStringEncoding allowLossyConversion:YES];
    sPrimeraLletra = [[NSString alloc] initWithData:dataPrimeraLletra encoding:NSASCIIStringEncoding];
    
    bool bComensaAmbVocal = [sPrimeraLletra isEqualToString:@"a"] || [sPrimeraLletra isEqualToString:@"e"] ||
    [sPrimeraLletra isEqualToString:@"i"] || [sPrimeraLletra isEqualToString:@"o"] ||
    [sPrimeraLletra isEqualToString:@"u"];
    
    return bComensaAmbVocal ? [NSString stringWithFormat:@"d'%@",[self converteixAMinusculaLaPrimeraLletra:paraula]] :
    [NSString stringWithFormat:@"de %@",[self converteixAMinusculaLaPrimeraLletra:paraula]];
    
}


+(NSString*)retornaIngredientARecepta:(NSString*)genere
                         nom_singular:(NSString*)nom_singular
                           nom_plural:(NSString*)nom_plural
                            quantitat:(NSString*)quantitat
                               unitat:(NSString*)unitat
                      utilitza_unitat:(NSString*)utilitza_unitat
{

    if(![nom_singular isEqualToString:@""])
    {
        
        // Usem expressió singular
        
        if([utilitza_unitat isEqualToString:@"1"])
        {
            
            // Utilitza unitat
            
            return [NSString stringWithFormat:@"%@ %@ %@", [quantitat stringByReplacingOccurrencesOfString:@"." withString:@","], unitat, [self retornaParaulaAmbPreposicio:[self converteixAMinusculaLaPrimeraLletra:nom_singular]]];
            
        }else{
            
            if([quantitat isEqualToString:@"0"]){
                
                return nom_singular;
                
            }else{
                
                bool bEsPlural = [quantitat floatValue] > 1;
                
                if((bEsPlural && [nom_plural isEqualToString:@""]) ||
                   ((!bEsPlural) && [nom_singular isEqualToString:@""]) ||
                   ((!bEsPlural) && [nom_plural isEqualToString:@""])){
                    
                    return nom_singular;
                    
                }
                
                if([quantitat isEqualToString:@"0.125"] ||
                   [quantitat isEqualToString:@"0.25"] ||
                   [quantitat isEqualToString:@"6"] ||
                   [quantitat isEqualToString:@"12"] ||
                   [quantitat isEqualToString:@"24"] ||
                   [quantitat isEqualToString:@"15"]){
                    
                    NSString *sForma = @"";
                    
                    if([quantitat isEqualToString:@"0.125"])sForma = @"Un octau";
                    if([quantitat isEqualToString:@"0.25"])sForma = @"Un quart";
                    if([quantitat isEqualToString:@"6"])sForma = @"Mitja dotzena";
                    if([quantitat isEqualToString:@"12"])sForma = @"Una dotzena";
                    if([quantitat isEqualToString:@"24"])sForma = @"Dos dotzenes";
                    if([quantitat isEqualToString:@"15"])sForma = @"Una quinzena";
                    
                    return [NSString stringWithFormat:@"%@ %@", sForma, [self retornaParaulaAmbPreposicio:[self converteixAMinusculaLaPrimeraLletra:bEsPlural ? nom_plural : nom_singular]]];
                    
                }
                
                if([quantitat isEqualToString:@"0.5"]){
                    
                    return [NSString stringWithFormat:@"%@ %@", [genere isEqualToString:@"M"] ? @"Mig" : @"Mitja", [self converteixAMinusculaLaPrimeraLletra: nom_singular]];
                    
                }
                
                if([quantitat isEqualToString:@"1.5"]){
                    
                    return [NSString stringWithFormat:@"%@ %@ i %@", [genere isEqualToString:@"M"] ? @"Un" : @"Una", [self converteixAMinusculaLaPrimeraLletra: nom_singular], [genere isEqualToString:@"M"] ? @"mig" : @"mitja"];
                    
                }
                
                if([quantitat isEqualToString:@"2.5"]){
                    
                    return [NSString stringWithFormat:@"Dos %@ i %@", [self converteixAMinusculaLaPrimeraLletra: nom_plural], [genere isEqualToString:@"M"] ? @"mig" : @"mitja"];
                    
                }
                
                return [NSString stringWithFormat:@"%@ %@", [quantitat stringByReplacingOccurrencesOfString:@"." withString:@","], [self converteixAMinusculaLaPrimeraLletra:bEsPlural ? nom_plural : nom_singular]];
                
            }
            
        }
        
    }else{
        
        // Usem expressió plural
        
        if([utilitza_unitat isEqualToString:@"1"])
        {
            
            // Utilitza unitat
            
            return [NSString stringWithFormat:@"%@ %@ %@", [quantitat stringByReplacingOccurrencesOfString:@"." withString:@","], unitat, [self retornaParaulaAmbPreposicio:[self converteixAMinusculaLaPrimeraLletra:nom_plural]]];
            
        }else{
            
            return nom_plural;
            
        }
        
    }
    
}

+(bool)ingredientEsPlural:(NSString*)utilitza_unitat
               nom_singular:(NSString*)nom_singular
               nom_plural:(NSString*)nom_plural
                quantitat:(NSString*)quantitat
{
    
    if([nom_singular isEqualToString:@""] && [utilitza_unitat isEqualToString:@"0"])return true;
    
    bool bEsPlural;
    
    if([utilitza_unitat isEqualToString:@"1"])
    {
        
        bEsPlural = [nom_singular isEqualToString:@""];
        
    }else{
        
        bEsPlural = [quantitat floatValue] > 1;
        
    }
    
    return bEsPlural;
    
}

+(NSString*)retornaIngredientAReceptaAmbArticle:(NSString*)utilitza_unitat
                                   nom_singular:(NSString*)nom_singular
                                     nom_plural:(NSString*)nom_plural
                                      quantitat:(NSString*)quantitat
                                         genere:(NSString*)genere
{
    
    if([nom_singular isEqualToString:@""] && [utilitza_unitat isEqualToString:@"0"])
    {
        
        return [self retornaParaulaAmbArticle:genere numero:@"P" paraula:nom_plural];
        
    }
    
    bool bEsPlural;
    
    if([utilitza_unitat isEqualToString:@"1"])
    {
        
        bEsPlural = [nom_singular isEqualToString:@""];
        
    }else{
        
        bEsPlural = [quantitat floatValue] > 1;
        
    }
    
    return [self retornaParaulaAmbArticle:genere numero:bEsPlural ? @"P" : @"S" paraula:bEsPlural ? nom_plural : nom_singular];
    
}

+(void)eliminaPreferencia:(NSString*)sPreferencia
{
    [[NSUserDefaults standardUserDefaults] setObject:nil forKey:sPreferencia];
    [[NSUserDefaults standardUserDefaults] synchronize];
}

+(NSString*)carregaPreferencia:(NSString*)sPreferencia
{
    return [[NSUserDefaults standardUserDefaults] objectForKey:sPreferencia];
}

+(NSString*)formataADoble:(NSString*)sEntrada
{
    
    NSString *sQuantitat = [sEntrada stringByReplacingOccurrencesOfString:@"," withString:@"."];
    
    double dQuantitat = sQuantitat.doubleValue;
    
    sQuantitat = [NSString stringWithFormat:@"%f", dQuantitat];
    
    NSString *sPartdecimal = [sQuantitat componentsSeparatedByString:@"."][1];
    
    if([sPartdecimal intValue] == 0)
    {
        sQuantitat = [sQuantitat componentsSeparatedByString:@"."][0];
    }else{
        while ([[sPartdecimal substringFromIndex:sPartdecimal.length-1] isEqualToString:@"0"])sPartdecimal = [sPartdecimal substringToIndex:sPartdecimal.length-1];
        sQuantitat = [[[sQuantitat componentsSeparatedByString:@"."][0] stringByAppendingString:@"."] stringByAppendingString:sPartdecimal];
    }
    
    return sQuantitat;
    
}

+(void)gravaPreferencia:(NSString*)sPreferencia valor:(NSString*)valor
{
    [[NSUserDefaults standardUserDefaults] setObject:valor forKey:sPreferencia];
    [[NSUserDefaults standardUserDefaults] synchronize];
}

+(UIImage *)filledImageFrom:(UIImage *)source withColor:(UIColor *)color{
    
    // begin a new image context, to draw our colored image onto with the right scale
    UIGraphicsBeginImageContextWithOptions(source.size, NO, [UIScreen mainScreen].scale);
    
    // get a reference to that context we created
    CGContextRef context = UIGraphicsGetCurrentContext();
    
    // set the fill color
    [color setFill];
    
    // translate/flip the graphics context (for transforming from CG* coords to UI* coords
    CGContextTranslateCTM(context, 0, source.size.height);
    CGContextScaleCTM(context, 1.0, -1.0);
    
    CGContextSetBlendMode(context, kCGBlendModeColorBurn);
    CGRect rect = CGRectMake(0, 0, source.size.width, source.size.height);
    CGContextDrawImage(context, rect, source.CGImage);
    
    CGContextSetBlendMode(context, kCGBlendModeSourceIn);
    CGContextAddRect(context, rect);
    CGContextDrawPath(context,kCGPathFill);
    
    // generate a new UIImage from the graphics context we drew onto
    UIImage *coloredImg = UIGraphicsGetImageFromCurrentImageContext();
    UIGraphicsEndImageContext();
    
    //return the color-burned image
    return coloredImg;
}

+(void)tabbarSetImages:(UITabBar*)tabBar imatges:(NSArray*)imatges imatgesFilled:(NSArray*)imatgesFilled colorSeleccio:(UIColor*)colorSeleccio colorDeseleccionat:(UIColor*)colorDeseleccionat
{
    
    int iIteracio = 0;
    
    for(UITabBarItem *oUITabBarItem in tabBar.items){
        
        // Color del text
        [oUITabBarItem setTitleTextAttributes:@{NSForegroundColorAttributeName: colorSeleccio} forState:UIControlStateSelected];
        [oUITabBarItem setTitleTextAttributes:@{NSForegroundColorAttributeName: colorDeseleccionat} forState:UIControlStateNormal];
        
        // Color de les imatges
        [oUITabBarItem setImage:[[self filledImageFrom:[imatges[iIteracio] copy] withColor:colorDeseleccionat] imageWithRenderingMode: UIImageRenderingModeAlwaysOriginal]];
        [oUITabBarItem setSelectedImage:[[self filledImageFrom:[imatgesFilled[iIteracio] copy] withColor:colorSeleccio] imageWithRenderingMode: UIImageRenderingModeAlwaysOriginal]];
        
        iIteracio++;
        
    }
    
}

+(void)tabbarSetTextos:(UITabBar*)tabBar colorSeleccio:(UIColor*)colorSeleccio colorDeseleccionat:(UIColor*)colorDeseleccionat
{
    
    for(UITabBarItem *oUITabBarItem in tabBar.items){
        
        // Color del text
        [oUITabBarItem setTitleTextAttributes:@{NSForegroundColorAttributeName: colorSeleccio} forState:UIControlStateSelected];
        [oUITabBarItem setTitleTextAttributes:@{NSForegroundColorAttributeName: colorDeseleccionat} forState:UIControlStateNormal];
        
    }
    
}

+(UIAlertController*)creaAlerta:(NSString*)titol descripcio:(NSString*)descripcio
{
    
    UIAlertController * alert = [UIAlertController
                                 alertControllerWithTitle:titol
                                 message:descripcio
                                 preferredStyle:UIAlertControllerStyleAlert];
    UIAlertAction *ok = [UIAlertAction actionWithTitle:@"D'acord" style:UIAlertActionStyleDefault
                                                   handler:^(UIAlertAction * action) {
                                                      
                                                   }];

    [alert addAction:ok];
    alert.view.tintColor = UIColorFromRGB(PALETA_COLOR_VERMELL);
    return alert;
    
}

+(NSMutableArray*)navigationBarAfegirBotonsDreta:(UIViewController*)viewcontroller aBotons:(NSArray*)aBotons
{
    
    NSMutableArray *aBotonsCreats = [[NSMutableArray alloc] init];
    
    for (NSDictionary *dictBoto in aBotons) {
        
        UIButton *btn = [UIButton buttonWithType:UIButtonTypeCustom];
        [btn setBackgroundImage:[UIImage imageNamed:dictBoto[@"imatge"]] forState:UIControlStateNormal];
        
        CGSize size = CGSizeMake(((NSNumber*)(dictBoto[@"size_w"])).floatValue, ((NSNumber*)(dictBoto[@"size_h"])).floatValue);
        
        [btn.widthAnchor constraintEqualToConstant: size.width].active = YES;
        [btn.heightAnchor constraintEqualToConstant:size.height].active = YES;
        [btn addTarget:dictBoto[@"target"] action:NSSelectorFromString(dictBoto[@"selector"]) forControlEvents:UIControlEventTouchUpInside];
        UIBarButtonItem *barBtnItem = [[UIBarButtonItem alloc] initWithCustomView:btn];
        
        [aBotonsCreats addObject:barBtnItem];
        
    }
    
    viewcontroller.navigationItem.rightBarButtonItems = aBotonsCreats;
    
    return aBotonsCreats;
    
}


+(UIBarButtonItem*)navigationBarAfegirBotoDreta:(UIViewController*)viewcontroller imatge:(UIImage*)imatge size:(CGSize)size action:(SEL)action target:(nullable id)target
{
    
    UIButton *btn = [UIButton buttonWithType:UIButtonTypeCustom];
    [btn setBackgroundImage:imatge forState:UIControlStateNormal];
    [btn.widthAnchor constraintEqualToConstant: size.width].active = YES;
    [btn.heightAnchor constraintEqualToConstant:size.height].active = YES;
    [btn addTarget:target action:action forControlEvents:UIControlEventTouchUpInside];
    UIBarButtonItem *barBtnItem = [[UIBarButtonItem alloc] initWithCustomView:btn];
    
    viewcontroller.navigationItem.rightBarButtonItem = barBtnItem;
    
    return barBtnItem;
    
}

+(UIBarButtonItem*)navigationBarAfegirBotoEsquerra:(UIViewController*)viewcontroller imatge:(UIImage*)imatge size:(CGSize)size action:(SEL)action target:(nullable id)target
{
    
    UIButton *btn = [UIButton buttonWithType:UIButtonTypeCustom];
    [btn setBackgroundImage:imatge forState:UIControlStateNormal];
    [btn.widthAnchor constraintEqualToConstant: size.width].active = YES;
    [btn.heightAnchor constraintEqualToConstant:size.height].active = YES;
    [btn addTarget:target action:action forControlEvents:UIControlEventTouchUpInside];
    UIBarButtonItem *barBtnItem = [[UIBarButtonItem alloc] initWithCustomView:btn];
    
    viewcontroller.navigationItem.leftBarButtonItem = barBtnItem;
    
    return barBtnItem;
    
}

+(UIView*)creaVistaPreloader:(UIViewController*)viewcontroller
{
    
    CGRect frameReferencia = viewcontroller.view.frame;
    
    UIView *vista_prel = [[UIView alloc] initWithFrame:CGRectMake(0, 0, frameReferencia.size.width, frameReferencia.size.height)];
    vista_prel.autoresizingMask = UIViewAutoresizingFlexibleWidth | UIViewAutoresizingFlexibleHeight;
    
    UIActivityIndicatorView *spinner = [[UIActivityIndicatorView alloc] initWithActivityIndicatorStyle:UIActivityIndicatorViewStyleLarge];
    spinner.color = UIColorFromRGB(PALETA_COLOR_VERMELL);
    [spinner startAnimating];
    
    UIView *vistaCentrada = [[UIView alloc] initWithFrame:CGRectMake(0, 0, spinner.frame.size.width, spinner.frame.size.width)];
    vistaCentrada.backgroundColor = UIColor.clearColor;
    CGRect rectCentrada = vistaCentrada.frame;
    rectCentrada.origin.x = (vista_prel.frame.size.width/2)-(spinner.frame.size.width/2);
    rectCentrada.origin.y = (vista_prel.frame.size.height/2)-(spinner.frame.size.width/2);
    vistaCentrada.frame = rectCentrada;
    [vista_prel addSubview:vistaCentrada];
    
    [vistaCentrada addSubview:spinner];
    
    vistaCentrada.autoresizingMask = UIViewAutoresizingFlexibleRightMargin | UIViewAutoresizingFlexibleTopMargin | UIViewAutoresizingFlexibleBottomMargin | UIViewAutoresizingFlexibleLeftMargin;
    
    vista_prel.backgroundColor = UIColor.whiteColor;
    
    [viewcontroller.view addSubview:vista_prel];
    
    return vista_prel;
    
}

@end
