//
//  ViewControllerAfegirIngredientRecepta.m
//  ataula
//
//  Created by Andreu Biosca on 07/04/2020.
//  Copyright © 2020 EGDBE. All rights reserved.
//

#import "ViewControllerAfegirIngredientRecepta.h"
#import "ViewControllerRecepta.h"
#import "IncludesCompartits.h"
#import "TabBarControllerPrincipal.h"
#import "ViewControllerIngredient.h"
#import "ViewControllerQuantitatIngredientARecepta.h"

@interface ViewControllerAfegirIngredientRecepta ()

@end

@implementation ViewControllerAfegirIngredientRecepta

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    
    // Vista preloader:
    self.vista_preloader = [IncludesCompartits creaVistaPreloader:self];
    self.vista_preloader.hidden = YES;
    
    self.title = @"Afegir ingredient";
    self.navigationController.navigationBar.tintColor = UIColorFromRGB(PALETA_COLOR_VERMELL);
    
    [self cercaIngredients:self.searchbar.text];
    
}

-(void)recercaIngredients
{
    
    [self cercaIngredients:self.searchbar.text];
    
}

-(void)cercaIngredients:(NSString*)sCerca
{
    
    self.iIdFilCercaValid++;
    
    __block int iIdFilCercaValid_valid = self.iIdFilCercaValid;
    
    AFHTTPSessionManager *manager = [[AFHTTPSessionManager alloc]initWithSessionConfiguration:[NSURLSessionConfiguration defaultSessionConfiguration]];
    [manager.requestSerializer setValue:@"application/x-www-form-urlencoded; charset=UTF-8" forHTTPHeaderField:@"Content-Type"];
    
    NSString *URL_WS = [NSString stringWithFormat:@"%@/API/cercaIngredients",WS_HOST];
    
    NSDictionary *parameters = @{
        @"cerca": sCerca
    };
    
    [manager POST:URL_WS parameters:parameters headers:nil progress:nil success:^(NSURLSessionDataTask * _Nonnull task, id  _Nullable responseObject) {
        
        // OK
        
        if(iIdFilCercaValid_valid == self.iIdFilCercaValid){
            
            NSDictionary *json = responseObject;
            
            self.aInstancies = [[NSMutableArray alloc] init];
            
            for (NSDictionary *dict in json[@"data"]) {
                
                [self.aInstancies addObject:dict];
                
            }
            
            if(iIdFilCercaValid_valid == self.iIdFilCercaValid)[self.tableview reloadData];

        }
        
    } failure:^(NSURLSessionDataTask * _Nullable task, NSError * _Nonnull error) {
        
        // KO
        
        [self presentViewController:[IncludesCompartits creaAlerta:@"Error"
                                                        descripcio:MISSATGE_ERROR_DEFECTE_WS] animated:YES completion:nil];
        
    }];
    
}

- (void)searchBar:(UISearchBar *)searchBar textDidChange:(NSString *)searchText
{

    [self cercaIngredients:searchText];
    
}

- (void)searchBarSearchButtonClicked:(UISearchBar *)searchBar
{
    
    [searchBar resignFirstResponder];
    
}

- (IBAction)creaNouIngredient:(id)sender {
    
    ViewControllerIngredient *oViewControllerIngredient = [[UIStoryboard storyboardWithName:@"Main" bundle:nil] instantiateViewControllerWithIdentifier:@"viewControllerIngredient"];
    oViewControllerIngredient.oViewControllerAfegirIngredientRecepta = self;
    [self.navigationController pushViewController:oViewControllerIngredient animated:YES];
    
}

#pragma mark Tableview delegate

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath
{
    
    return 49;
    
}

- (UITableViewCell *)tableView:(UITableView *)aTableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    
    float amplada_pantalla = [[UIScreen mainScreen] bounds].size.width;
    
    NSString *sReuseIdentifier = @"IngredientAReceptaVC_cell_reuse_identifier";
    
    UITableViewCell *cell = [aTableView dequeueReusableCellWithIdentifier:sReuseIdentifier];
    
    // Càlculs comuns
    
    NSDictionary *dictEntitat = self.aInstancies[indexPath.row];
    
    NSString *titol = ![dictEntitat[@"nom_singular"] isEqualToString:@""] ? dictEntitat[@"nom_singular"] : dictEntitat[@"nom_plural"];
    
    int iWidth_labels = amplada_pantalla-30;
    
    NSMutableAttributedString * atributtedString_TITOL = [[NSMutableAttributedString alloc] initWithString:titol];
    
    if((self.dictIngredientSeleccionat != nil) &&
       ([self.dictIngredientSeleccionat[@"id"] isEqualToString:dictEntitat[@"id"]]))
    {
        
        [atributtedString_TITOL addAttribute:NSFontAttributeName value:[UIFont boldSystemFontOfSize:17] range: NSMakeRange(0,[titol length])];
        [atributtedString_TITOL addAttribute:NSForegroundColorAttributeName value:[UIColor blackColor] range: NSMakeRange(0,[titol length])];
        
    }else{
        
        [atributtedString_TITOL addAttribute:NSFontAttributeName value:[UIFont systemFontOfSize:16] range: NSMakeRange(0,[titol length])];
        [atributtedString_TITOL addAttribute:NSForegroundColorAttributeName value:[UIColor blackColor] range: NSMakeRange(0,[titol length])];
        
    }
    
    if(cell == nil)
    {
        
        //NSLog(@"CELL = NIL");
        
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:sReuseIdentifier];
        
        UILabel * labelcell_TITOL = [[UILabel alloc]initWithFrame:CGRectMake(14, 4, iWidth_labels, 40)];
        labelcell_TITOL.attributedText = atributtedString_TITOL; // ?¿
        labelcell_TITOL.numberOfLines = 2;
        labelcell_TITOL.backgroundColor = UIColor.clearColor;
        labelcell_TITOL.tag = 1;
        [cell.contentView addSubview:labelcell_TITOL];
        
    }else{
        
        //NSLog(@"CELL <> NIL");
        
        for (UIView * subview in cell.contentView.subviews) {
            
            if([subview class] == [UILabel  class])
            {
                
                if(subview.tag == 1)((UILabel*)subview).attributedText = atributtedString_TITOL;
                
            }

        }
        
    }
    
    return cell;
    
}

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    
    return 1;
    
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    
    if(self.aInstancies == nil)return 0;
    
    return self.aInstancies.count;
    
}

- (void)tableView:(UITableView *)tableView willDisplayCell:(UITableViewCell *)cell forRowAtIndexPath:(NSIndexPath *)indexPath
{
    
    [cell setBackgroundColor:[UIColor clearColor]];
    
}

- (void)tableView: (UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    
    [tableView deselectRowAtIndexPath:indexPath animated:NO];
    
    NSDictionary *dictEntitat = self.aInstancies[indexPath.row];
    
    self.dictIngredientSeleccionat = dictEntitat;
    
    [self.tableview reloadRowsAtIndexPaths:self.tableview.indexPathsForVisibleRows withRowAnimation:UITableViewRowAnimationFade];
    
    if([self.searchbar isFirstResponder])[self.searchbar resignFirstResponder];
    
    self.vista_pas_2.hidden = NO;
    
    // Posar alpha si cal al botó de número i desactivar-lo (o treure alpha i activar-lo)
    // Posar grams o mililitr.
    
    self.boto_numero.enabled = !([dictEntitat[@"nom_singular"] isEqualToString:@""] ||
                                [dictEntitat[@"nom_plural"] isEqualToString:@""]);
    
    self.boto_numero.alpha = [dictEntitat[@"nom_singular"] isEqualToString:@""] ||
                             [dictEntitat[@"nom_plural"] isEqualToString:@""] ? .1 : 1;
    
    self.label_o_be.alpha = self.boto_numero.alpha;
    
    [self.boto_unitat setTitle:[dictEntitat[@"unitat"] isEqualToString:@"g"] ? @"grams" : @"mililítr." forState:UIControlStateNormal];
    
}

- (IBAction)clickBotoNumero:(id)sender {

    bool bEsPlural = [self.dictIngredientSeleccionat[@"nom_singular"] isEqualToString:@""];
    
    ViewControllerQuantitatIngredientARecepta *oViewControllerQuantitatIngredientARecepta = [[UIStoryboard storyboardWithName:@"Main" bundle:nil] instantiateViewControllerWithIdentifier:@"viewControllerQuantitatIngredientARecepta"];
    oViewControllerQuantitatIngredientARecepta.oViewControllerAfegirIngredientRecepta = self;
    oViewControllerQuantitatIngredientARecepta.modalPresentationStyle = UIModalPresentationOverCurrentContext;
    oViewControllerQuantitatIngredientARecepta.ingredientAmbPreposicio = [IncludesCompartits retornaParaulaAmbPreposicio:[IncludesCompartits converteixAMinusculaLaPrimeraLletra:bEsPlural ? self.dictIngredientSeleccionat[@"nom_plural"] : self.dictIngredientSeleccionat[@"nom_singular"]]];
    oViewControllerQuantitatIngredientARecepta.genere = self.dictIngredientSeleccionat[@"genere"];
    [self presentViewController:oViewControllerQuantitatIngredientARecepta animated:YES completion:^{}];
    
}

- (IBAction)clickBotoUnitat:(id)sender {
    
    bool bEsPlural = [self.dictIngredientSeleccionat[@"nom_singular"] isEqualToString:@""];
    
    NSString *sUnitat = [self.dictIngredientSeleccionat[@"unitat"] isEqualToString:@"g"] ? @"grams" : @"mililitres";
    
    UIAlertController *alert= [UIAlertController
                               alertControllerWithTitle:@"Quantitat"
                               message:[NSString stringWithFormat:@"Indica la quantitat %@ en %@:",[IncludesCompartits retornaParaulaAmbPreposicio:[IncludesCompartits converteixAMinusculaLaPrimeraLletra:bEsPlural ? self.dictIngredientSeleccionat[@"nom_plural"] : self.dictIngredientSeleccionat[@"nom_singular"]]], sUnitat]
                               preferredStyle:UIAlertControllerStyleAlert];
    
    UIAlertAction* ok = [UIAlertAction actionWithTitle:@"D'acord" style:UIAlertActionStyleDefault
                                               handler:^(UIAlertAction * action){
        
        [alert dismissViewControllerAnimated:YES completion:nil];
        
        UITextField *textField = alert.textFields[0];
        
        NSString *sQuantitat = [IncludesCompartits formataADoble:textField.text];
        
        self.vista_preloader.hidden = NO;
        [self.navigationItem setHidesBackButton:YES animated:YES];
        
        AFHTTPSessionManager *manager = [[AFHTTPSessionManager alloc]initWithSessionConfiguration:[NSURLSessionConfiguration defaultSessionConfiguration]];
        [manager.requestSerializer setValue:@"application/x-www-form-urlencoded; charset=UTF-8" forHTTPHeaderField:@"Content-Type"];
        
        NSString *URL_WS = [NSString stringWithFormat:@"%@/API/afegirIngredientARecepta",WS_HOST];
        
        NSDictionary *parameters = @{
            @"id_ingredient": self.dictIngredientSeleccionat[@"id"],
            @"id_recepta": self.oViewControllerRecepta.idRecepta,
            @"quantitat": sQuantitat,
            @"utilitza_unitat": [sQuantitat isEqualToString:@"0"] ? @"0" : @"1"
        };
        
        [manager POST:URL_WS parameters:parameters headers:nil progress:nil success:^(NSURLSessionDataTask * _Nonnull task, id  _Nullable responseObject) {
            
            // OK
            
            NSDictionary *json = responseObject;
            
            if([json[@"result"] intValue] == 1)
            {
                
                // KO
                self.vista_preloader.hidden = YES;
                [self.navigationItem setHidesBackButton:NO animated:YES];
                
                [self presentViewController:[IncludesCompartits creaAlerta:@"Error" descripcio:json[@"error"]] animated:YES completion:nil];
                
            }else{
                
                [self.oViewControllerRecepta refrescaIngredientsRecepta];
                [self.navigationController popViewControllerAnimated:YES];
                
            }
            
        } failure:^(NSURLSessionDataTask * _Nullable task, NSError * _Nonnull error) {
            
            // KO
            self.vista_preloader.hidden = YES;
            [self.navigationItem setHidesBackButton:NO animated:YES];
            
            [self presentViewController:[IncludesCompartits creaAlerta:@"Error" descripcio:@"Hi ha hagut un error de connexió a l'hora de pujar la fotografia."] animated:YES completion:nil];
            
        }];
        
    }];
    
    UIAlertAction* cancel = [UIAlertAction actionWithTitle:@"Cancel·la" style:UIAlertActionStyleDefault
                                                   handler:^(UIAlertAction * action) {
        
        [alert dismissViewControllerAnimated:YES completion:nil];
        
    }];
    
    alert.view.tintColor = UIColorFromRGB(PALETA_COLOR_VERMELL);
    
    [alert addAction:ok];
    [alert addAction:cancel];
    
    [alert addTextFieldWithConfigurationHandler:^(UITextField *textField) {
        textField.keyboardType = UIKeyboardTypeDecimalPad;
    }];
    
    [self presentViewController:alert animated:YES completion:nil];
    
}

- (void)scrollViewWillBeginDragging:(UIScrollView *)scrollView
{
    
    if([self.searchbar isFirstResponder])[self.searchbar resignFirstResponder];
    
}

@end
