//
//  ViewControllerEstri.m
//  ataula
//
//  Created by Andreu Biosca on 06/04/2020.
//  Copyright © 2020 EGDBE. All rights reserved.
//

#import "ViewControllerEstri.h"
#import "IncludesCompartits.h"
#import "TabBarControllerPrincipal.h"
#import "ViewControllerEstris.h"

@interface ViewControllerEstri ()

@end

@implementation ViewControllerEstri

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    
    // Creació precàrrrega
    
    // Vista preloader:
    self.vista_preloader = [IncludesCompartits creaVistaPreloader:self];
    self.vista_preloader.hidden = YES;
    
    self.title = self.idEstri == nil ? @"Afegir estri" : @"Editar estri";
    [self.boto_accio setTitle:self.idEstri == nil ? @"Afegir estri" : @"Editar estri" forState:UIControlStateNormal];
    self.navigationController.navigationBar.tintColor = UIColorFromRGB(PALETA_COLOR_VERMELL);
    
    if(self.idEstri == nil)
    {
        
        // Mode afegir

        self.boto_genere_M.alpha = 1;
        self.boto_genere_F.alpha = ALPHA_BOTO_DESELECCIONAT;
        
        self.boto_accio.enabled = true;
        
    }else{
        
        // Mode editar
        
        AFHTTPSessionManager *manager = [[AFHTTPSessionManager alloc]initWithSessionConfiguration:[NSURLSessionConfiguration defaultSessionConfiguration]];
        [manager.requestSerializer setValue:@"application/x-www-form-urlencoded; charset=UTF-8" forHTTPHeaderField:@"Content-Type"];
        
        NSString *URL_WS = [NSString stringWithFormat:@"%@/API/getEstri",WS_HOST];
        
        NSDictionary *parameters = @{
            @"id": self.idEstri
        };
        
        [manager POST:URL_WS parameters:parameters headers:nil progress:nil success:^(NSURLSessionDataTask * _Nonnull task, id  _Nullable responseObject) {
            
            // OK
            
            NSDictionary *json = responseObject;
            
            if([json[@"result"] intValue] == 1)
            {
                
                // KO
                [self.navigationController popViewControllerAnimated:YES];
                
            }else{
                
                NSDictionary *dictEntitat = json[@"data"];
                self.textfield_nom.text = dictEntitat[@"nom"];

                if([dictEntitat[@"genere"] isEqualToString:@"M"])
                {
                    
                    self.boto_genere_M.alpha = 1;
                    self.boto_genere_F.alpha = ALPHA_BOTO_DESELECCIONAT;
                    
                }else{
                    
                    self.boto_genere_M.alpha = ALPHA_BOTO_DESELECCIONAT;
                    self.boto_genere_F.alpha = 1;
                    
                }
                
                self.boto_accio.enabled = true;
                
            }
            
        } failure:^(NSURLSessionDataTask * _Nullable task, NSError * _Nonnull error) {
          
            // KO
            [self.navigationController popViewControllerAnimated:YES];
            
        }];
        
    }
    
}

- (IBAction)clickBotoGenere_M:(id)sender {
    
    [self.textfield_nom resignFirstResponder];
    
    self.boto_genere_M.alpha = 1;
    self.boto_genere_F.alpha = ALPHA_BOTO_DESELECCIONAT;
    
}

- (IBAction)clickBotoGenere_F:(id)sender {
    
    [self.textfield_nom resignFirstResponder];
    
    self.boto_genere_M.alpha = ALPHA_BOTO_DESELECCIONAT;
    self.boto_genere_F.alpha = 1;
    
}


- (IBAction)clickBotoAccio:(id)sender {
    
    [self.textfield_nom resignFirstResponder];
    
    if([self.textfield_nom.text isEqualToString:@""]){
        
        [self presentViewController:[IncludesCompartits creaAlerta:@"Atenció" descripcio:@"Has d'especificar el nom de l'estri per continuar."] animated:YES completion:nil];
        
        return;
        
    }
    
    self.vista_preloader.hidden = NO;
    [self.navigationItem setHidesBackButton:YES animated:YES];
    
    AFHTTPSessionManager *manager = [[AFHTTPSessionManager alloc]initWithSessionConfiguration:[NSURLSessionConfiguration defaultSessionConfiguration]];
    [manager.requestSerializer setValue:@"application/x-www-form-urlencoded; charset=UTF-8" forHTTPHeaderField:@"Content-Type"];
    
    NSString *sWSaction = self.idEstri == nil ? @"afegirEstri" : @"editarEstri";
    
    NSString *URL_WS = [NSString stringWithFormat:@"%@/API/%@", WS_HOST, sWSaction];
    
    NSMutableDictionary *parameters = [[NSMutableDictionary alloc] initWithDictionary:@{
        @"nom": self.textfield_nom.text,
        @"genere": (int)trunc(self.boto_genere_M.alpha) == (int)trunc(ALPHA_BOTO_DESELECCIONAT) ? @"F" : @"M"
    }];
    
    if(self.idEstri != nil)[parameters setValue:self.idEstri forKey:@"id_estri"];
    
    [manager POST:URL_WS parameters:parameters headers:nil progress:nil success:^(NSURLSessionDataTask * _Nonnull task, id  _Nullable responseObject) {
        
        // OK
        
        NSDictionary *json = responseObject;
        
        if([json[@"result"] intValue] == 1)
        {
        
            self.vista_preloader.hidden = YES;
            [self.navigationItem setHidesBackButton:NO animated:YES];
            
            [self presentViewController:[IncludesCompartits creaAlerta:@"Error" descripcio:json[@"error"]] animated:YES completion:nil];
            
        }else{

            [self.oViewControllerEstris recercaEstris];
            
            [self.navigationController popViewControllerAnimated:YES];

        }
        
    } failure:^(NSURLSessionDataTask * _Nullable task, NSError * _Nonnull error) {
        
        // KO
        
        self.vista_preloader.hidden = YES;
        [self.navigationItem setHidesBackButton:NO animated:YES];
        
        [self presentViewController:[IncludesCompartits creaAlerta:@"Atenció" descripcio:@"Hi ha hagut un error de connexió i no s'ha pogut efectuar l'acció."] animated:YES completion:nil];
        
    }];
    
}

@end
