//
//  ViewControllerIngredient.m
//  ataula
//
//  Created by Andreu Biosca on 04/04/2020.
//  Copyright © 2020 EGDBE. All rights reserved.
//

#import "ViewControllerIngredient.h"
#import "IncludesCompartits.h"
#import "TabBarControllerPrincipal.h"
#import "ViewControllerIngredients.h"
#import "ViewControllerAfegirIngredientRecepta.h"

@interface ViewControllerIngredient ()

@end

@implementation ViewControllerIngredient
    
- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    
    [[NSNotificationCenter defaultCenter] addObserver:self
                                             selector:@selector(keyboardWillShow:)
                                                 name:UIKeyboardWillShowNotification
                                               object:nil];
    
    [[NSNotificationCenter defaultCenter] addObserver:self
                                             selector:@selector(keyboardWillHide:)
                                                 name:UIKeyboardWillHideNotification
                                               object:nil];
    
    // Creació precàrrrega
    
    // Vista preloader:
    self.vista_preloader = [IncludesCompartits creaVistaPreloader:self];
    self.vista_preloader.hidden = YES;

    
    // calcular tamany contingut scrollview
    float y_max = 0;
    for (UIView *subvista in self.scrollview.subviews)
    {
        if(![NSStringFromClass(subvista.class) isEqualToString:@"_UIScrollViewScrollIndicator"])y_max = MAX(y_max, subvista.frame.origin.y + subvista.frame.size.height + 50);
    }
    self.scrollview.contentSize = CGSizeMake(self.scrollview.frame.size.width, y_max+0);
    
    self.title = self.idIngredient == nil ? @"Afegir ingredient" : @"Editar ingredient";
    [self.boto_accio setTitle:self.idIngredient == nil ? @"Afegir ingredient" : @"Editar ingredient" forState:UIControlStateNormal];
    self.navigationController.navigationBar.tintColor = UIColorFromRGB(PALETA_COLOR_VERMELL);
    
    if(self.idIngredient == nil)
    {
        
        // Mode afegir
        
        self.camera.hidden = NO;
        
        self.boto_genere_M.alpha = 1;
        self.boto_genere_F.alpha = ALPHA_BOTO_DESELECCIONAT;
        self.boto_unitat_g.alpha = 1;
        self.boto_unitat_ml.alpha = ALPHA_BOTO_DESELECCIONAT;
        
        self.boto_accio.enabled = true;
        
    }else{
        
        // Mode editar
        
        AFHTTPSessionManager *manager = [[AFHTTPSessionManager alloc]initWithSessionConfiguration:[NSURLSessionConfiguration defaultSessionConfiguration]];
        [manager.requestSerializer setValue:@"application/x-www-form-urlencoded; charset=UTF-8" forHTTPHeaderField:@"Content-Type"];
        
        NSString *URL_WS = [NSString stringWithFormat:@"%@/API/getIngredient",WS_HOST];
        
        NSDictionary *parameters = @{
            @"id": self.idIngredient
        };
        
        [manager POST:URL_WS parameters:parameters headers:nil progress:nil success:^(NSURLSessionDataTask * _Nonnull task, id  _Nullable responseObject) {
            
            // OK
            
            NSDictionary *json = responseObject;
            
            if([json[@"result"] intValue] == 1)
            {
                
                // KO
                [self.navigationController popViewControllerAnimated:YES];
                
            }else{
                
                NSDictionary *dictEntitat = json[@"data"];
                self.textfield_nom_singular.text = dictEntitat[@"nom_singular"];
                self.textfield_nom_plural.text = dictEntitat[@"nom_plural"];
                
                self.bForçarAmbduesFormes = (![dictEntitat[@"nom_singular"] isEqualToString:@""]) &&
                                            (![dictEntitat[@"nom_plural"] isEqualToString:@""]);
                
                if([dictEntitat[@"genere"] isEqualToString:@"M"])
                {
                    
                    self.boto_genere_M.alpha = 1;
                    self.boto_genere_F.alpha = ALPHA_BOTO_DESELECCIONAT;
                    
                }else{
                    
                    self.boto_genere_M.alpha = ALPHA_BOTO_DESELECCIONAT;
                    self.boto_genere_F.alpha = 1;
                    
                }
                
                if([dictEntitat[@"unitat"] isEqualToString:@"g"])
                {
                    
                    self.boto_unitat_g.alpha = 1;
                    self.boto_unitat_ml.alpha = ALPHA_BOTO_DESELECCIONAT;
                    
                }else{
                    
                    self.boto_unitat_g.alpha = ALPHA_BOTO_DESELECCIONAT;
                    self.boto_unitat_ml.alpha = 1;
                    
                }
                
                NSString *url_imatge = [dictEntitat[@"foto"] isEqualToString:@""] ? @"" : [NSString stringWithFormat:@"%@%@",WS_HOST,dictEntitat[@"foto"]];
                
                if([url_imatge isEqualToString:@""])
                {
                    
                    self.camera.hidden = NO;
                    
                    self.boto_accio.enabled = true;
                    
                }else{
                    
                    dispatch_queue_t thread_CARREGAFOTO=dispatch_queue_create("thread_CARREGAFOTO", NULL);
                    dispatch_async(thread_CARREGAFOTO, ^{
                        
                        // WS, TASCA LLARGA,...
                        NSData * imgdata = [NSData dataWithContentsOfURL:[NSURL URLWithString:url_imatge]];
                        
                        dispatch_async(dispatch_get_main_queue(), ^{
                            
                            // UI CHANGES
                            if (imgdata == nil)
                            {
                                self.camera.hidden = NO;
                            }else{
                                [self refrescaFoto:[UIImage imageWithData:imgdata]];
                            }
                            
                            self.boto_accio.enabled = true;
                            
                        });
                        
                    });
                    
                }
                
            }
            
        } failure:^(NSURLSessionDataTask * _Nullable task, NSError * _Nonnull error) {
          
            // KO
            [self.navigationController popViewControllerAnimated:YES];
            
        }];
        
    }
    
    self.scrollview.delegate = self;
    
}

- (IBAction)clickBotoGenere_M:(id)sender {
    
    [self.textfield_nom_singular resignFirstResponder];
    [self.textfield_nom_plural resignFirstResponder];
    
    self.boto_genere_M.alpha = 1;
    self.boto_genere_F.alpha = ALPHA_BOTO_DESELECCIONAT;
    
}

- (IBAction)clickBotoGenere_F:(id)sender {
    
    [self.textfield_nom_singular resignFirstResponder];
    [self.textfield_nom_plural resignFirstResponder];
    
    self.boto_genere_M.alpha = ALPHA_BOTO_DESELECCIONAT;
    self.boto_genere_F.alpha = 1;
    
}

- (IBAction)clickBotoUnitat_g:(id)sender {
    
    [self.textfield_nom_singular resignFirstResponder];
    [self.textfield_nom_plural resignFirstResponder];
    
    self.boto_unitat_g.alpha = 1;
    self.boto_unitat_ml.alpha = ALPHA_BOTO_DESELECCIONAT;
    
}

- (IBAction)clickBotoUnitat_ml:(id)sender {
    
    [self.textfield_nom_singular resignFirstResponder];
    [self.textfield_nom_plural resignFirstResponder];
    
    self.boto_unitat_g.alpha = ALPHA_BOTO_DESELECCIONAT;
    self.boto_unitat_ml.alpha = 1;
    
}

- (IBAction)clickBotoAccio:(id)sender {
    
    [self.textfield_nom_singular resignFirstResponder];
    [self.textfield_nom_plural resignFirstResponder];
    
    
    if(([self.textfield_nom_singular.text isEqualToString:@""]) &&
       ([self.textfield_nom_plural.text isEqualToString:@""])){
        
        [self presentViewController:[IncludesCompartits creaAlerta:@"Atenció"
                                                        descripcio:@"Almenys has d'especificar el nom en singular o plural (mínim una de les dues formes) per continuar"]
                           animated:YES
                         completion:nil];
        
        return;
        
    }
    
    if(self.bForçarAmbduesFormes)
    {
        
        if(([self.textfield_nom_singular.text isEqualToString:@""]) ||
           ([self.textfield_nom_plural.text isEqualToString:@""])){
            
            [self presentViewController:[IncludesCompartits creaAlerta:@"Atenció"
                                                            descripcio:@"Has d'especificar el nom en singular i plural perquè la darrera vegada que es va desar aquest ingredient incloïa les 2 formes"]
                               animated:YES
                             completion:nil];
            
            return;
            
        }
        
    }
    
    self.vista_preloader.hidden = NO;
    [self.navigationItem setHidesBackButton:YES animated:YES];
    
    AFHTTPSessionManager *manager = [[AFHTTPSessionManager alloc]initWithSessionConfiguration:[NSURLSessionConfiguration defaultSessionConfiguration]];
    [manager.requestSerializer setValue:@"application/x-www-form-urlencoded; charset=UTF-8" forHTTPHeaderField:@"Content-Type"];
    
    NSString *sWSaction = self.idIngredient == nil ? @"afegirIngredient" : @"editarIngredient";
    
    NSString *URL_WS = [NSString stringWithFormat:@"%@/API/%@", WS_HOST, sWSaction];
    
    NSMutableDictionary *parameters = [[NSMutableDictionary alloc] initWithDictionary:@{
        @"nom_singular": self.textfield_nom_singular.text,
        @"nom_plural": self.textfield_nom_plural.text,
        @"genere": (int)trunc(self.boto_genere_M.alpha) == (int)trunc(ALPHA_BOTO_DESELECCIONAT) ? @"F" : @"M",
        @"unitat": (int)trunc(self.boto_unitat_g.alpha) == (int)trunc(ALPHA_BOTO_DESELECCIONAT) ? @"ml" : @"g"
    }];
    
    if(self.idIngredient != nil)[parameters setValue:self.idIngredient forKey:@"id_ingredient"];
    
    [manager POST:URL_WS parameters:parameters headers:nil progress:nil success:^(NSURLSessionDataTask * _Nonnull task, id  _Nullable responseObject) {
        
        // OK
        
        NSDictionary *json = responseObject;
        
        if([json[@"result"] intValue] == 1)
        {
        
            self.vista_preloader.hidden = YES;
            [self.navigationItem setHidesBackButton:NO animated:YES];
            
            [self presentViewController:[IncludesCompartits creaAlerta:@"Error" descripcio:json[@"error"]] animated:YES completion:nil];
            
        }else{
            
            if(self.dataNovaImatge == nil)
            {
                
                // No cal alctualitzar la fotografia
                
                if(self.oViewControllerIngredients != nil)
                {
                    
                    // Tornem al llistat d'ingredients
                    
                    [self.oViewControllerIngredients recercaIngredients];
                    
                }else{
                    
                    // Tornem a seleccionar ingredient d'una recepta
                    
                    [self.oViewControllerAfegirIngredientRecepta recercaIngredients];
                    
                }
                
                [self.navigationController popViewControllerAnimated:YES];
                
            }else{
            
                // Actualitzem fotografia
                
                NSString *id_ingredient = self.idIngredient == nil ? json[@"data"] : self.idIngredient;
                
                dispatch_queue_t thread_UPLOADFOTO=dispatch_queue_create("thread_UPLOADFOTO", NULL);
                dispatch_async(thread_UPLOADFOTO, ^{

                    NSString *boundary = @"---------------------------14737809831466499882746641449";
                    
                    NSMutableData *body = [NSMutableData data];
                    
                    // Paràmetres
                    
                    NSDictionary *params = @{@"id_ingredient" : id_ingredient};
                    
                    [params enumerateKeysAndObjectsUsingBlock:^(NSString *parameterKey, NSString *parameterValue, BOOL *stop) {
                        [body appendData:[[NSString stringWithFormat:@"--%@\r\n", boundary] dataUsingEncoding:NSUTF8StringEncoding]];
                        [body appendData:[[NSString stringWithFormat:@"Content-Disposition: form-data; name=\"%@\"\r\n\r\n", parameterKey] dataUsingEncoding:NSUTF8StringEncoding]];
                        [body appendData:[[NSString stringWithFormat:@"%@\r\n", parameterValue] dataUsingEncoding:NSUTF8StringEncoding]];
                    }];
                    
                    NSMutableURLRequest *request = [[NSMutableURLRequest alloc] init];
                    
                    [request setURL:[NSURL URLWithString:[NSString stringWithFormat:@"%@/API/carregarFotoIngredient", WS_HOST]]];
                    [request setHTTPMethod:@"POST"];
                    
                    NSString *contentType = [NSString stringWithFormat:@"multipart/form-data; boundary=%@",boundary];
                    [request addValue:contentType forHTTPHeaderField: @"Content-Type"];
                    
                    [body appendData:[[NSString stringWithFormat:@"\r\n--%@\r\n",boundary] dataUsingEncoding:NSUTF8StringEncoding]];
                    int num_rnd = arc4random() % 1000;
                    [body appendData:[[NSString stringWithFormat:@"Content-Disposition: form-data; name=\"attachments\"; filename=\"%i.jpg\"\r\n",num_rnd] dataUsingEncoding:NSUTF8StringEncoding]];
                    [body appendData:[@"Content-Type: application/octet-stream\r\n\r\n" dataUsingEncoding:NSUTF8StringEncoding]];
                    [body appendData:[NSData dataWithData:self.dataNovaImatge]];
                    [body appendData:[[NSString stringWithFormat:@"\r\n--%@--\r\n",boundary] dataUsingEncoding:NSUTF8StringEncoding]];
                    
                    [request setHTTPBody:body];
                    NSData *dataResponse = [NSURLConnection sendSynchronousRequest:request returningResponse:nil error:nil];
                    
                    dispatch_async(dispatch_get_main_queue(), ^{
                        
                        if(dataResponse)
                        {
                            
                            NSDictionary *json = [NSJSONSerialization JSONObjectWithData:dataResponse options:kNilOptions error:nil];
                            
                            if([json[@"result"] intValue] == 1)
                            {
                                
                                self.vista_preloader.hidden = YES;
                                [self.navigationItem setHidesBackButton:NO animated:YES];
                                
                                [self presentViewController:[IncludesCompartits creaAlerta:@"Error" descripcio:json[@"error"]] animated:YES completion:nil];
                                
                            }else{
                                
                                // Borrem memòria cau de la imatge
                                
                                NSString *url_imatge = [NSString stringWithFormat:@"%@/Imatges_elements/Ingredients/%@_thumb.jpg",WS_HOST,id_ingredient];
                                
                                TabBarControllerPrincipal *oTabBarControllerPrincipal = (TabBarControllerPrincipal*)self.tabBarController;
                                
                                [oTabBarControllerPrincipal.dictImatgesIngredientsCollectionCachejades removeObjectForKey:url_imatge];
                                
                                // Tornem al llistat de receptes
                                
                                if(self.oViewControllerIngredients != nil)
                                {
                                    
                                    // Tornem al llistat d'ingredients
                                    
                                    [self.oViewControllerIngredients recercaIngredients];
                                    
                                }else{
                                    
                                    // Tornem a seleccionar ingredient d'una recepta
                                    
                                    [self.oViewControllerAfegirIngredientRecepta recercaIngredients];
                                    
                                }
                                
                                [self.navigationController popViewControllerAnimated:YES];
                                
                            }
                            
                        }else{
                            
                            self.vista_preloader.hidden = YES;
                            [self.navigationItem setHidesBackButton:NO animated:YES];
                            
                            [self presentViewController:[IncludesCompartits creaAlerta:@"Error"
                                                                            descripcio:@"Hi ha hagut un error de connexió a l'hora de pujar la fotografia."] animated:YES completion:nil];
                            
                        }
                        
                    });
                    
                });
            
            }
            
        }
        
    } failure:^(NSURLSessionDataTask * _Nullable task, NSError * _Nonnull error) {
        
        // KO
        
        self.vista_preloader.hidden = YES;
        [self.navigationItem setHidesBackButton:NO animated:YES];
        
        [self presentViewController:[IncludesCompartits creaAlerta:@"Atenció"
                                                        descripcio:@"Hi ha hagut un error de connexió i no s'ha pogut efectuar l'acció."] animated:YES completion:nil];
        
    }];
    
}

- (IBAction)clickSeleccionarFotografia:(id)sender {
    
    [self.textfield_nom_singular resignFirstResponder];
    [self.textfield_nom_plural resignFirstResponder];
    
    bool bEsiPad = [[UIDevice currentDevice].model rangeOfString:@"iPad"].location != NSNotFound;
    
    UIAlertController *alert = [UIAlertController alertControllerWithTitle:nil
                                                                   message:nil
                                                            preferredStyle:bEsiPad ? UIAlertControllerStyleAlert : UIAlertControllerStyleActionSheet];
    
    UIAlertAction *ferFotoAccio = [UIAlertAction actionWithTitle:@"Fer foto"
                                                           style:UIAlertActionStyleDefault handler:^(UIAlertAction * action) {
        
        UIImagePickerController * pickerLibrary = [[UIImagePickerController alloc] init];
        pickerLibrary.sourceType = UIImagePickerControllerSourceTypeCamera;
        pickerLibrary.delegate = self;
        [self presentViewController:pickerLibrary animated:YES completion:^{}];
        
    }];
    
    [alert addAction:ferFotoAccio];
    
    UIAlertAction *seleccionarFotoAccio = [UIAlertAction actionWithTitle:@"Seleccionar foto del rodet"
                                                                   style:UIAlertActionStyleDefault handler:^(UIAlertAction * action) {
        
        UIImagePickerController * pickerLibrary = [[UIImagePickerController alloc] init];
        pickerLibrary.sourceType = UIImagePickerControllerSourceTypePhotoLibrary;
        pickerLibrary.delegate = self;
        [self presentViewController:pickerLibrary animated:YES completion:^{}];

    }];
    
    [alert addAction:seleccionarFotoAccio];
    
    if((self.imgvFoto != nil) && self.imgvFoto.image != nil)
    {
        
        [alert addAction:[UIAlertAction actionWithTitle:@"Mostrar foto actual" style:UIAlertActionStyleDefault handler:^(UIAlertAction * action) {
            
            self.aTempDocumentURL = [[NSMutableArray alloc]init];
            [self.aTempDocumentURL addObject:[NSURL fileURLWithPath:[NSTemporaryDirectory() stringByAppendingPathComponent:@"Recepta.jpg"]]];
            [UIImageJPEGRepresentation(self.imgvFoto.image, 1) writeToURL:self.aTempDocumentURL[0] atomically:NO];
            
            QLPreviewController *oQLPreviewController = [[QLPreviewController alloc]init];
            oQLPreviewController.dataSource = self;
            oQLPreviewController.delegate = self;
            oQLPreviewController.modalPresentationStyle = UIModalPresentationFullScreen;
            oQLPreviewController.currentPreviewItemIndex = 0;
            
            [self presentViewController:oQLPreviewController animated:YES completion:NULL];
            
        }]];
        
    }
    
    [alert addAction:[UIAlertAction actionWithTitle:@"Cancel·la" style:UIAlertActionStyleCancel handler:^(UIAlertAction * action) {}]];
    
    [self presentViewController:alert animated:YES completion:nil];
    
}

#pragma mark QuickLook data source

- (id)previewController:(QLPreviewController *)previewController previewItemAtIndex:(NSInteger)index
{
    
    return self.aTempDocumentURL[index];
    
}

- (NSInteger)numberOfPreviewItemsInPreviewController:(QLPreviewController *)controller
{
    
    return self.aTempDocumentURL.count;
    
}

- (void)imagePickerController:(UIImagePickerController *)picker didFinishPickingMediaWithInfo:(NSDictionary<UIImagePickerControllerInfoKey, id> *)info;
{
    
    [self dismissViewControllerAnimated:YES completion:^{
        
        UIImage *image = [info objectForKey:UIImagePickerControllerOriginalImage];
        
        self.dataNovaImatge = UIImageJPEGRepresentation([IncludesCompartits getResizedImage:image iMaxWidth:800 iMaxHeight:800], 0.8);
        [self refrescaFoto:image];
        
    }];
    
}

-(void)scrollViewDidScroll:(UIScrollView *)scrollView
{
    
    if(scrollView == self.scrollview)
    {
    
        // Capçalera enganxosa
        
        if(scrollView.contentOffset.y < 0)
        {
            CGRect rectCapsalera = self.vista_capsalera.frame;
            rectCapsalera.origin.y = scrollView.contentOffset.y;
            rectCapsalera.size.height = 211 + ((-1)*scrollView.contentOffset.y);
            if((self.imgvFoto != nil) && (self.imgvFoto.image != nil))[self refrescaFoto:self.imgvFoto.image];
            self.vista_capsalera.frame = rectCapsalera;
        }
        
    }
    
}

-(void)refrescaFoto:(UIImage*)foto
{
    
    self.camera.hidden = YES;
    
    CALayer * l = [self.vistaFoto layer];
    [l setMasksToBounds:YES];
    l.borderWidth = 0;
    
    float width = foto.size.width;
    float height = foto.size.height;
    
    float amplada_definitiva = self.vistaFoto.frame.size.width;
    float alsada_definitiva = self.vistaFoto.frame.size.height;
    
    CGRect rectFoto;
    
    if(height>width)
    {
        
        float ratio = amplada_definitiva/width;
        rectFoto = CGRectMake((amplada_definitiva/2)-((width*ratio)/2),
                              (alsada_definitiva/2)-((height*ratio)/2),
                              width*ratio,
                              height*ratio);
        if(rectFoto.size.height < alsada_definitiva)
        {
            float ratio = alsada_definitiva/rectFoto.size.height;
            rectFoto = CGRectMake((amplada_definitiva/2)-((rectFoto.size.width*ratio)/2),
                                  (alsada_definitiva/2)-((rectFoto.size.height*ratio)/2),
                                  rectFoto.size.width*ratio,
                                  rectFoto.size.height*ratio);
        }
        
    }else{
        
        // width > height
        float ratio = alsada_definitiva/height;
        rectFoto = CGRectMake((amplada_definitiva/2)-((width*ratio)/2),
                              (alsada_definitiva/2)-((height*ratio)/2),
                              width*ratio,
                              height*ratio);
        if(rectFoto.size.width < amplada_definitiva)
        {
            float ratio = amplada_definitiva/rectFoto.size.width;
            rectFoto = CGRectMake((amplada_definitiva/2)-((rectFoto.size.width*ratio)/2),
                                  (alsada_definitiva/2)-((rectFoto.size.height*ratio)/2),
                                  rectFoto.size.width*ratio,
                                  rectFoto.size.height*ratio);
        }
        
    }
    
    if(self.imgvFoto == nil)
    {
        self.imgvFoto = [[UIImageView alloc] initWithFrame:rectFoto];
    }else{
        self.imgvFoto.frame = rectFoto;
    }
    
    self.imgvFoto.image = foto;
    
    if([self.imgvFoto superview] != self.vistaFoto)[self.vistaFoto addSubview:self.imgvFoto];
    
}

-(void)keyboardWillShow:(NSNotification *)notification {
    
    if([[UIApplication sharedApplication] applicationState] != UIApplicationStateActive)return;
    
    CGRect keyboardRect = [[[notification userInfo] valueForKey:UIKeyboardFrameEndUserInfoKey] CGRectValue];
    CGRect rectActual = self.scrollview.frame;
    rectActual.size.height = (self.view.frame.size.height) - (keyboardRect.size.height);
  
    // Animació
    
    [UIView animateWithDuration:[[[notification userInfo] valueForKey:UIKeyboardAnimationDurationUserInfoKey] floatValue]
                          delay:.02
                        options:[[[notification userInfo]
                                 valueForKey:UIKeyboardAnimationCurveUserInfoKey]intValue] animations:^{
        [self.scrollview setFrame:rectActual];
    } completion:^(BOOL finished) {
        
    }];
    
}

-(void)keyboardWillHide:(NSNotification *)notification {
    
    if([[UIApplication sharedApplication] applicationState] != UIApplicationStateActive)return;
    
    CGRect rectActual = self.scrollview.frame;
    rectActual.size.height = self.view.frame.size.height;

    // Animació
    
    [UIView animateWithDuration:[[[notification userInfo] valueForKey:UIKeyboardAnimationDurationUserInfoKey] floatValue]
                          delay:.02
                        options:[[[notification userInfo]
                                 valueForKey:UIKeyboardAnimationCurveUserInfoKey]intValue] animations:^{
        [self.scrollview setFrame:rectActual];
    } completion:^(BOOL finished) {
        
    }];
    
}

@end
