//
//  ViewControllerPas.m
//  ataula
//
//  Created by Andreu Biosca on 08/04/2020.
//  Copyright © 2020 EGDBE. All rights reserved.
//

#import "ViewControllerPas.h"
#import "ViewControllerRecepta.h"
#import "IncludesCompartits.h"
#import "TextViewPas.h"
#import "TabBarControllerPrincipal.h"
#import "CollectionViewCellPredictiu.h"

@interface ViewControllerPas ()

@end

@implementation ViewControllerPas

- (IBAction)clickFons:(id)sender {
    
    if([self.textview_predicció isFirstResponder])[self.textview_predicció resignFirstResponder];
    
}


- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    
    // Vista preloader:
    self.vista_preloader = [IncludesCompartits creaVistaPreloader:self];
    self.vista_preloader.hidden = YES;
    
    // calcular tamany contingut scrollview
    float y_max = 0;
    for (UIView *subvista in self.scrollview.subviews)
    {
        if(![NSStringFromClass(subvista.class) isEqualToString:@"_UIScrollViewScrollIndicator"])y_max = MAX(y_max, subvista.frame.origin.y + subvista.frame.size.height + 50);
    }
    self.scrollview.contentSize = CGSizeMake(self.scrollview.frame.size.width, y_max+0);
    
    self.botoSeguentBlocPredictiu.contentEdgeInsets = UIEdgeInsetsMake(4, 4, 4, 4);
    
    // Arrodonir fotos
    for (int i=1; i<=3; i++) {
        
        UIView *vistaFoto = [self valueForKey:[NSString stringWithFormat:@"vistaFoto%i",i]];
        
        CALayer * l = vistaFoto.layer;
        [l setMasksToBounds:YES];
        [l setCornerRadius:10];
        l.borderWidth = 0;
        
    }
    
    // Arrodonim collection view i la seva capçalera
    
    UIBezierPath *maskPath = [UIBezierPath bezierPathWithRoundedRect:self.vistaFonsCollectionView.bounds byRoundingCorners:(UIRectCornerBottomLeft | UIRectCornerBottomRight) cornerRadii:CGSizeMake(15.0, 15.0)];

    CAShapeLayer *maskLayer = [[CAShapeLayer alloc] init];
    maskLayer.frame = self.vistaFonsCollectionView.bounds;
    maskLayer.path  = maskPath.CGPath;
    self.vistaFonsCollectionView.layer.mask = maskLayer;
    
    UIBezierPath *maskPath2 = [UIBezierPath bezierPathWithRoundedRect:self.vista_capçalera_predictiu.bounds byRoundingCorners:(UIRectCornerTopLeft | UIRectCornerTopRight) cornerRadii:CGSizeMake(15.0, 15.0)];

    CAShapeLayer *maskLayer2 = [[CAShapeLayer alloc] init];
    maskLayer2.frame = self.vista_capçalera_predictiu.bounds;
    maskLayer2.path  = maskPath2.CGPath;
    self.vista_capçalera_predictiu.layer.mask = maskLayer2;
    
    [self.textview_predicció setModePlaceholder];
    self.textview_predicció.delegate = self.textview_predicció;
    self.textview_predicció.oViewControllerPas = self;
    
    self.title = self.idPas == nil ? @"Afegir pas" : @"Editar pas";
    [self.boto_accio setTitle:self.idPas == nil ? @"Afegir pas" : @"Editar pas" forState:UIControlStateNormal];
    self.navigationController.navigationBar.tintColor = UIColorFromRGB(PALETA_COLOR_VERMELL);
    
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(keyboardWillShow:) name:UIKeyboardWillShowNotification object:nil];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(keyboardWillHide:) name:UIKeyboardWillHideNotification object:nil];
    
    // Configuració collectionview:
    
    // Inicialització diccionari predictiu
    
    self.aPrediccio = [[NSMutableArray alloc] init];
    [self.aPrediccio addObject:@{@"titol":@"ACCIÓ",
                                 @"valors":@[@"Fregir", @"Coure", @"Bullir", @"Fornejar", @"Escòrrer", @"Salpebrar",
                                             @"Salar", @"Arrebossar", @"Afegir", @"Dessalar", @"Torrar", @"Posar", @"Remenar"]
    }];
    [self.aPrediccio addObject:@{@"titol":@"INGREDIENT",
                                 @"valors":[NSNull null]
    }];
    [self.aPrediccio addObject:@{@"titol":@"ESTAT",
                                 @"valors":@[@[@"picat", @"picada", @"picats", @"picades"],
                                             @[@"tallat", @"tallada", @"tallats", @"tallades"],
                                             @[@"laminat", @"laminada", @"laminats", @"laminades"],
                                             @[@"a daus", @"a daus", @"a daus", @"a daus"],
                                             @[@"ratllat", @"ratllada", @"ratllats", @"ratllades"],
                                             @[@"esqueixat", @"esqueixada", @"esqueixats", @"esqueixades"],
                                             @[@"tallat per la meitat", @"tallada per la meitat", @"tallats per la meitat", @"tallades per la meitat"]]
    }];
    [self.aPrediccio addObject:@{@"titol":@"ESTRI",
                                 @"valors":[NSNull null]
    }];
    [self.aPrediccio addObject:@{@"titol":@"POTÈNCIA",
                                 @"valors":@[@[@"250°", @"200°", @"180°", @"150°", @"120°"],
                                             @[@"foc lent", @"foc mig", @"foc mig/fort", @"foc fort"]]
    }];
    [self.aPrediccio addObject:@{@"titol":@"TEMPS",
                                 @"valors":@[@"½ minut", @"1 minut", @"5 minuts", @"10 minuts", @"15 minuts",
                                             @"½ hora", @"1 hora", @"90 minuts", @"2 hores"]
    }];
    
    // Delegate i responder
    
    [self.collectionview registerClass:[CollectionViewCellPredictiu class] forCellWithReuseIdentifier:@"CollectionViewCellPredictiu"];

    UICollectionViewFlowLayout *layout = [[UICollectionViewFlowLayout alloc] init];
    
    bool bEsiPad = [[UIDevice currentDevice].model rangeOfString:@"iPad"].location != NSNotFound;
    
    float amplada_item = self.collectionview.frame.size.width / (bEsiPad ? 5 : 3);
    
    CGSize size = CGSizeMake(amplada_item, 50);
    
    layout.itemSize = CGSizeMake(size.width, size.height);
    
    [self.collectionview setCollectionViewLayout:layout];
    
    self.collectionview.delegate = self;
    
    self.collectionview.dataSource = self;
    
    [self carregaEstris];
    
    self.aFotosEliminar = [[NSMutableArray alloc] initWithArray:@[@"0", @"0", @"0"]];
    
}

-(void)carregaEstris
{
    
    // Carrega estris
    
    AFHTTPSessionManager *manager = [[AFHTTPSessionManager alloc]initWithSessionConfiguration:[NSURLSessionConfiguration defaultSessionConfiguration]];
    [manager.requestSerializer setValue:@"application/x-www-form-urlencoded; charset=UTF-8" forHTTPHeaderField:@"Content-Type"];
    
    NSString *URL_WS = [NSString stringWithFormat:@"%@/API/cercaEstris",WS_HOST];
    
    NSDictionary *parameters = @{
        @"cerca": @""
    };
    
    [manager POST:URL_WS parameters:parameters headers:nil progress:nil success:^(NSURLSessionDataTask * _Nonnull task, id  _Nullable responseObject) {
        
        // OK
        
        NSDictionary *json = responseObject;
        
        self.aInstancies_estris = [[NSMutableArray alloc] init];
        
        for (NSDictionary *dict in json[@"data"])[self.aInstancies_estris addObject:dict];
            
        // Càrrega de contingut
        
        if(self.idPas == nil)
        {
            
            // Mode afegir
            
            for (int i=1; i<=3; i++) {
            
                UIView *camera = [self valueForKey:[NSString stringWithFormat:@"camera%i",i]];
                
                camera.hidden = NO;
            
            }
            
            self.boto_accio.enabled = true;
            
            [self reiniciaPredictiuEnFuncioTextView];
            
        }else{
            
            // Mode editar
            
            AFHTTPSessionManager *manager = [[AFHTTPSessionManager alloc]initWithSessionConfiguration:[NSURLSessionConfiguration defaultSessionConfiguration]];
            [manager.requestSerializer setValue:@"application/x-www-form-urlencoded; charset=UTF-8" forHTTPHeaderField:@"Content-Type"];
            
            NSString *URL_WS = [NSString stringWithFormat:@"%@/API/getPas",WS_HOST];
            
            NSDictionary *parameters = @{
                @"id": self.idPas
            };
            
            [manager POST:URL_WS parameters:parameters headers:nil progress:nil success:^(NSURLSessionDataTask * _Nonnull task, id  _Nullable responseObject) {
                
                // OK
                
                NSDictionary *json = responseObject;
                
                if([json[@"result"] intValue] == 1)
                {
                    
                    // KO
                    [self.navigationController popViewControllerAnimated:YES];
                    
                }else{
                    
                    NSDictionary *dictEntitat = json[@"data"];
                    
                    if(![dictEntitat[@"descripcio"] isEqualToString:@""])
                    {
                        [self.textview_predicció setModeNormal];
                        self.textview_predicció.text = dictEntitat[@"descripcio"];
                    }
                    
                    for (int i=1; i<=3; i++) {
                        
                        NSString *nom_foto = [NSString stringWithFormat:@"foto%i",i];
                        
                        NSString *url_imatge = [dictEntitat[nom_foto] isEqualToString:@""] ? @"" : [NSString stringWithFormat:@"%@%@",WS_HOST,dictEntitat[nom_foto]];
                        
                        if([url_imatge isEqualToString:@""])
                        {
                            
                            UIView *camera = [self valueForKey:[NSString stringWithFormat:@"camera%i",i]];
                            
                            camera.hidden = NO;
                            
                            if(i==3)self.boto_accio.enabled = true;
                            
                        }else{
                            
                            dispatch_queue_t thread_CARREGAFOTO=dispatch_queue_create("thread_CARREGAFOTO", NULL);
                            dispatch_async(thread_CARREGAFOTO, ^{
                                
                                // WS, TASCA LLARGA,...
                                NSData * imgdata = [NSData dataWithContentsOfURL:[NSURL URLWithString:url_imatge]];
                                
                                dispatch_async(dispatch_get_main_queue(), ^{
                                    
                                    // UI CHANGES
                                    if (imgdata == nil)
                                    {
                                        UIView *camera = [self valueForKey:[NSString stringWithFormat:@"camera%i",i]];
                                        camera.hidden = NO;
                                    }else{
                                        self.sTagFotoSeleccionada = [NSString stringWithFormat:@"%i",i];
                                        [self refrescaFoto:[UIImage imageWithData:imgdata]];
                                    }
                                    
                                    if(i==3)self.boto_accio.enabled = true;
                                    
                                });
                                
                            });
                            
                        }
                        
                    }
                    
                    [self reiniciaPredictiuEnFuncioTextView];
                    
                }
                
            } failure:^(NSURLSessionDataTask * _Nullable task, NSError * _Nonnull error) {
              
                // KO
                [self.navigationController popViewControllerAnimated:YES];
                
            }];
            
        }
        
    } failure:^(NSURLSessionDataTask * _Nullable task, NSError * _Nonnull error) {
        
        // KO
        
        [self.navigationController popViewControllerAnimated:YES];
        
    }];
    
}

-(void)reiniciaPredictiuEnFuncioTextView
{
    
    bool bTextViewBuit = [self.textview_predicció esModePlaceholder] || ((![self.textview_predicció esModePlaceholder]) && ([self.textview_predicció.text isEqualToString:@""]));
    bool bTextViewAcabaEnPunt = (!bTextViewBuit) &&
                                ([[self.textview_predicció.text substringFromIndex:self.textview_predicció.text.length-1]
                                                                   isEqualToString:@"."]);
    
    NSMutableArray *aAccionsNormalitzat = [[NSMutableArray alloc] init];
    
    for (NSString *sAccio in self.aPrediccio[0][@"valors"]) {
        
        NSString *primerCaracter = (bTextViewBuit || bTextViewAcabaEnPunt) ? [[sAccio substringToIndex:1] uppercaseString] :
                                                                             [[sAccio substringToIndex:1] lowercaseString];
        
        NSString *sAccio_norm = [[sAccio lowercaseString] stringByReplacingCharactersInRange:NSMakeRange(0,1) withString: primerCaracter];
        
        [aAccionsNormalitzat addObject:sAccio_norm];
        
    }
    
    NSMutableDictionary *dictAccions = [[NSMutableDictionary alloc] init];
    [dictAccions setValue:self.aPrediccio[0][@"titol"] forKey:@"titol"];
    [dictAccions setValue:aAccionsNormalitzat forKey:@"valors"];
    
    [self.aPrediccio replaceObjectAtIndex:0 withObject:dictAccions];
    
    self.iBlocPrediccioActual = 0;
    self.label_capçalera_predictiu.text = self.aPrediccio[self.iBlocPrediccioActual][@"titol"];
    self.aParaulesCollectionView = self.aPrediccio[self.iBlocPrediccioActual][@"valors"];
    self.label_capçalera_predictiu.hidden = NO;
    self.botoSeguentBlocPredictiu.hidden = YES;
    
    [self.collectionview reloadData];
    
    self.id_estri_escollit = -1;
    
    self.bHemAfegitIngredient = false;
    
    self.rangDarreraIIngredient = NSMakeRange(0, 0);
    
}



- (IBAction)clickSeleccionarFotografia:(id)sender {
    
    [self.textview_predicció resignFirstResponder];

    UIButton *boto = (UIButton*)sender;
    
    self.sTagFotoSeleccionada = [NSString stringWithFormat:@"%i", (int)boto.tag];
    
    
    bool bEsiPad = [[UIDevice currentDevice].model rangeOfString:@"iPad"].location != NSNotFound;
    
    UIAlertController *alert = [UIAlertController alertControllerWithTitle:nil
                                                                   message:nil
                                                            preferredStyle:bEsiPad ? UIAlertControllerStyleAlert : UIAlertControllerStyleActionSheet];
    
    UIAlertAction *ferFotoAccio = [UIAlertAction actionWithTitle:@"Fer foto"
                                                           style:UIAlertActionStyleDefault handler:^(UIAlertAction * action) {
        
        UIImagePickerController * pickerLibrary = [[UIImagePickerController alloc] init];
        pickerLibrary.sourceType = UIImagePickerControllerSourceTypeCamera;
        pickerLibrary.delegate = self;
        [self presentViewController:pickerLibrary animated:YES completion:^{}];
        
    }];
    
    [alert addAction:ferFotoAccio];
    
    UIAlertAction *seleccionarFotoAccio = [UIAlertAction actionWithTitle:@"Seleccionar foto del rodet"
                                                                   style:UIAlertActionStyleDefault handler:^(UIAlertAction * action) {
        
        UIImagePickerController * pickerLibrary = [[UIImagePickerController alloc] init];
        pickerLibrary.sourceType = UIImagePickerControllerSourceTypePhotoLibrary;
        pickerLibrary.delegate = self;
        [self presentViewController:pickerLibrary animated:YES completion:^{}];

    }];
    
    [alert addAction:seleccionarFotoAccio];
    
    UIImageView *imgvFoto = [self valueForKey:[NSString stringWithFormat:@"imgvFoto%@",self.sTagFotoSeleccionada]];
    
    if((imgvFoto != nil) && imgvFoto.image != nil)
    {
        
        [alert addAction:[UIAlertAction actionWithTitle:@"Mostrar foto actual" style:UIAlertActionStyleDefault handler:^(UIAlertAction * action) {
            
            self.aTempDocumentURL = [[NSMutableArray alloc]init];
            [self.aTempDocumentURL addObject:[NSURL fileURLWithPath:[NSTemporaryDirectory() stringByAppendingPathComponent:@"Recepta.jpg"]]];
            [UIImageJPEGRepresentation(imgvFoto.image, 1) writeToURL:self.aTempDocumentURL[0] atomically:NO];
            
            QLPreviewController *oQLPreviewController = [[QLPreviewController alloc]init];
            oQLPreviewController.dataSource = self;
            oQLPreviewController.delegate = self;
            oQLPreviewController.modalPresentationStyle = UIModalPresentationFullScreen;
            oQLPreviewController.currentPreviewItemIndex = 0;
            
            [self presentViewController:oQLPreviewController animated:YES completion:NULL];
            
        }]];
        
    }
    
    if((imgvFoto != nil) && imgvFoto.image != nil)
    {
        
        [alert addAction:[UIAlertAction actionWithTitle:@"Elimina foto" style:UIAlertActionStyleDestructive handler:^(UIAlertAction * action) {
            
            [self.aFotosEliminar replaceObjectAtIndex:self.sTagFotoSeleccionada.intValue-1 withObject:@"1"];
            [self setValue:nil forKey:[NSString stringWithFormat:@"dataNovaImatge%@",self.sTagFotoSeleccionada]];
            [self refrescaFoto:nil];
            
        }]];
        
    }
    
    [alert addAction:[UIAlertAction actionWithTitle:@"Cancel·la" style:UIAlertActionStyleCancel handler:^(UIAlertAction * action) {}]];
    
    [self presentViewController:alert animated:YES completion:nil];
    
}

- (void)imagePickerController:(UIImagePickerController *)picker didFinishPickingMediaWithInfo:(NSDictionary<UIImagePickerControllerInfoKey, id> *)info;
{
    
    [self dismissViewControllerAnimated:YES completion:^{
        
        UIImage *image = [info objectForKey:UIImagePickerControllerOriginalImage];
        
        [self setValue:UIImageJPEGRepresentation([IncludesCompartits getResizedImage:image iMaxWidth:800 iMaxHeight:800], 0.8) forKey:[NSString stringWithFormat:@"dataNovaImatge%@",self.sTagFotoSeleccionada]];
        
        [self.aFotosEliminar replaceObjectAtIndex:self.sTagFotoSeleccionada.intValue-1 withObject:@"0"];
        
        [self refrescaFoto:image];
        
    }];
    
}


-(void)refrescaFoto:(UIImage*)foto
{
    
    UIView *camera = [self valueForKey:[NSString stringWithFormat:@"camera%@",self.sTagFotoSeleccionada]];
    
    camera.hidden = YES;
    
    UIView *vistaFoto = [self valueForKey:[NSString stringWithFormat:@"vistaFoto%@",self.sTagFotoSeleccionada]];
    UIImageView *imgvFoto = [self valueForKey:[NSString stringWithFormat:@"imgvFoto%@",self.sTagFotoSeleccionada]];
    
    if(foto == nil)
    {
        camera.hidden = NO;
        imgvFoto.image = nil;
        return;
    }
    
    CALayer * l = [vistaFoto layer];
    [l setMasksToBounds:YES];
    l.borderWidth = 0;
    
    float width = foto.size.width;
    float height = foto.size.height;
    
    float amplada_definitiva = vistaFoto.frame.size.width;
    float alsada_definitiva = vistaFoto.frame.size.height;
    
    CGRect rectFoto;
    
    if(height>width)
    {
        
        float ratio = amplada_definitiva/width;
        rectFoto = CGRectMake((amplada_definitiva/2)-((width*ratio)/2), (alsada_definitiva/2)-((height*ratio)/2), width*ratio, height*ratio);
        if(rectFoto.size.height < alsada_definitiva)
        {
            float ratio = alsada_definitiva/rectFoto.size.height;
            rectFoto = CGRectMake((amplada_definitiva/2)-((rectFoto.size.width*ratio)/2), (alsada_definitiva/2)-((rectFoto.size.height*ratio)/2), rectFoto.size.width*ratio, rectFoto.size.height*ratio);
        }
        
    }else{
        
        // width > height
        float ratio = alsada_definitiva/height;
        rectFoto = CGRectMake((amplada_definitiva/2)-((width*ratio)/2), (alsada_definitiva/2)-((height*ratio)/2), width*ratio, height*ratio);
        if(rectFoto.size.width < amplada_definitiva)
        {
            float ratio = amplada_definitiva/rectFoto.size.width;
            rectFoto = CGRectMake((amplada_definitiva/2)-((rectFoto.size.width*ratio)/2), (alsada_definitiva/2)-((rectFoto.size.height*ratio)/2), rectFoto.size.width*ratio, rectFoto.size.height*ratio);
        }
        
    }
    
    if(imgvFoto == nil)
    {
        imgvFoto = [[UIImageView alloc] initWithFrame:rectFoto];
    }else{
        imgvFoto.frame = rectFoto;
    }
    
    imgvFoto.image = foto;
    
    [self setValue:imgvFoto forKey:[NSString stringWithFormat:@"imgvFoto%@",self.sTagFotoSeleccionada]];
    
    if([imgvFoto superview] != vistaFoto)[vistaFoto addSubview:imgvFoto];
    
    
}

-(void)keyboardWillShow:(NSNotification *)notification {
    
    if([[UIApplication sharedApplication] applicationState] != UIApplicationStateActive)return;
    
    CGRect keyboardRect = [[[notification userInfo] valueForKey:UIKeyboardFrameEndUserInfoKey] CGRectValue];
    CGRect rectActual = self.scrollview.frame;
    rectActual.size.height = (self.view.frame.size.height) - (keyboardRect.size.height);
  
    // Animació
    
    [UIView animateWithDuration:[[[notification userInfo] valueForKey:UIKeyboardAnimationDurationUserInfoKey] floatValue]
                          delay:.02
                        options:[[[notification userInfo]
                                 valueForKey:UIKeyboardAnimationCurveUserInfoKey]intValue] animations:^{
        [self.scrollview setFrame:rectActual];
    } completion:^(BOOL finished) {
        
    }];
    
}

-(void)keyboardWillHide:(NSNotification *)notification {
    
    if([[UIApplication sharedApplication] applicationState] != UIApplicationStateActive)return;
    
    CGRect rectActual = self.scrollview.frame;
    rectActual.size.height = self.view.frame.size.height;

    // Animació
    
    [UIView animateWithDuration:[[[notification userInfo] valueForKey:UIKeyboardAnimationDurationUserInfoKey] floatValue]
                          delay:.02
                        options:[[[notification userInfo]
                                 valueForKey:UIKeyboardAnimationCurveUserInfoKey]intValue] animations:^{
        [self.scrollview setFrame:rectActual];
    } completion:^(BOOL finished) {
        
    }];
    
}

- (IBAction)clickBotoAccio:(id)sender {
    
    [self.textview_predicció resignFirstResponder];
    
    self.vista_preloader.hidden = NO;
    [self.navigationItem setHidesBackButton:YES animated:YES];
    
    AFHTTPSessionManager *manager = [[AFHTTPSessionManager alloc]initWithSessionConfiguration:[NSURLSessionConfiguration defaultSessionConfiguration]];
    [manager.requestSerializer setValue:@"application/x-www-form-urlencoded; charset=UTF-8" forHTTPHeaderField:@"Content-Type"];
    
    NSString *sWSaction = self.idPas == nil ? @"afegirPas" : @"editarPas";
    
    NSString *indexosFotosEliminar = self.idPas == nil ? @"" : [self.aFotosEliminar componentsJoinedByString:@","];
    
    NSString *URL_WS = [NSString stringWithFormat:@"%@/API/%@", WS_HOST, sWSaction];
    
    NSMutableDictionary *parameters = [[NSMutableDictionary alloc] initWithDictionary:@{
        @"descripcio": [self.textview_predicció esModePlaceholder] ? @"" : self.textview_predicció.text,
        @"id_recepta": self.oViewControllerRecepta.idRecepta,
        @"indexos_fotos_eliminar": indexosFotosEliminar
    }];
    
    if(self.idPas != nil)[parameters setValue:self.idPas forKey:@"id_pas"];
    
    [manager POST:URL_WS parameters:parameters headers:nil progress:nil success:^(NSURLSessionDataTask * _Nonnull task, id  _Nullable responseObject) {
        
        // OK
        
        NSDictionary *json = responseObject;
        
        if([json[@"result"] intValue] == 1)
        {
        
            self.vista_preloader.hidden = YES;
            [self.navigationItem setHidesBackButton:NO animated:YES];
            
            [self presentViewController:[IncludesCompartits creaAlerta:@"Error" descripcio:json[@"error"]] animated:YES completion:nil];
            
        }else{
            
            self.iBucleFotosActual = 1;
            [self iteraBucleUploadFoto: self.idPas != nil ? self.idPas : json[@"data"]];
            
        }
        
    } failure:^(NSURLSessionDataTask * _Nullable task, NSError * _Nonnull error) {
        
        // KO
        
        self.vista_preloader.hidden = YES;
        [self.navigationItem setHidesBackButton:NO animated:YES];
        
        [self presentViewController:[IncludesCompartits creaAlerta:@"Atenció" descripcio:@"Hi ha hagut un error de connexió i no s'ha pogut efectuar l'acció."] animated:YES completion:nil];
        
    }];
    
}

-(void)iteraBucleUploadFoto:(NSString*)id_pas_afegit
{
    
    bool bHiHaFotoPendents = false;
    
    for (int i=self.iBucleFotosActual; i<=3; i++) {
    
        NSData *dataNovaImatge = [self valueForKey:[NSString stringWithFormat:@"dataNovaImatge%i",i]];
        
        if(dataNovaImatge != nil)bHiHaFotoPendents = true;
        
    }
    
    if(!bHiHaFotoPendents)
    {
        [self.oViewControllerRecepta refrescaPassosRecepta];
        [self.navigationController popViewControllerAnimated:YES];
        return;
    }
    
    NSData *dataNovaImatge = [self valueForKey:[NSString stringWithFormat:@"dataNovaImatge%i",self.iBucleFotosActual]];
    
    if(bHiHaFotoPendents && (dataNovaImatge == nil))
    {
        self.iBucleFotosActual++;
        [self iteraBucleUploadFoto: id_pas_afegit];
        return;
    }
    
    // Actualitzem fotografia
    
    NSString *id_pas = self.idPas == nil ? id_pas_afegit : self.idPas;
    
    dispatch_queue_t thread_UPLOADFOTO=dispatch_queue_create("thread_UPLOADFOTO", NULL);
    dispatch_async(thread_UPLOADFOTO, ^{
        
        NSString *boundary = @"---------------------------14737809831466499882746641449";
        
        NSMutableData *body = [NSMutableData data];
        
        // Paràmetres
        
        NSDictionary *params = @{
            @"id_pas" : id_pas,
            @"num_foto" : [NSString stringWithFormat:@"%i",self.iBucleFotosActual]
        };
        
        [params enumerateKeysAndObjectsUsingBlock:^(NSString *parameterKey, NSString *parameterValue, BOOL *stop) {
            [body appendData:[[NSString stringWithFormat:@"--%@\r\n", boundary] dataUsingEncoding:NSUTF8StringEncoding]];
            [body appendData:[[NSString stringWithFormat:@"Content-Disposition: form-data; name=\"%@\"\r\n\r\n", parameterKey] dataUsingEncoding:NSUTF8StringEncoding]];
            [body appendData:[[NSString stringWithFormat:@"%@\r\n", parameterValue] dataUsingEncoding:NSUTF8StringEncoding]];
        }];
        
        NSMutableURLRequest *request = [[NSMutableURLRequest alloc] init];
        
        [request setURL:[NSURL URLWithString:[NSString stringWithFormat:@"%@/API/carregarFotoPas", WS_HOST]]];
        [request setHTTPMethod:@"POST"];
        
        NSString *contentType = [NSString stringWithFormat:@"multipart/form-data; boundary=%@",boundary];
        [request addValue:contentType forHTTPHeaderField: @"Content-Type"];
        
        [body appendData:[[NSString stringWithFormat:@"\r\n--%@\r\n",boundary] dataUsingEncoding:NSUTF8StringEncoding]];
        int num_rnd = arc4random() % 1000;
        [body appendData:[[NSString stringWithFormat:@"Content-Disposition: form-data; name=\"attachments\"; filename=\"%i.jpg\"\r\n",num_rnd] dataUsingEncoding:NSUTF8StringEncoding]];
        [body appendData:[@"Content-Type: application/octet-stream\r\n\r\n" dataUsingEncoding:NSUTF8StringEncoding]];
        [body appendData:[NSData dataWithData:dataNovaImatge]];
        [body appendData:[[NSString stringWithFormat:@"\r\n--%@--\r\n",boundary] dataUsingEncoding:NSUTF8StringEncoding]];
        
        [request setHTTPBody:body];
        NSData *dataResponse = [NSURLConnection sendSynchronousRequest:request returningResponse:nil error:nil];
        
        dispatch_async(dispatch_get_main_queue(), ^{
            
            if(dataResponse)
            {
                
                NSDictionary *json = [NSJSONSerialization JSONObjectWithData:dataResponse options:kNilOptions error:nil];
                
                if([json[@"result"] intValue] == 1)
                {
                    
                    self.iBucleFotosActual++;
                    [self iteraBucleUploadFoto: id_pas_afegit];
                    
                }else{
                    
                    // Borrem memòria cau de la imatge
                    
                    NSString *url_imatge = [NSString stringWithFormat:@"%@/Imatges_elements/Passos/%@_%@_thumb.jpg",WS_HOST,id_pas,[NSString stringWithFormat:@"%i",self.iBucleFotosActual]];
                    
                    TabBarControllerPrincipal *oTabBarControllerPrincipal = (TabBarControllerPrincipal*)self.tabBarController;
                    
                    [oTabBarControllerPrincipal.dictImatgesPassosTableviewCachejades removeObjectForKey:url_imatge];
                    
                    self.iBucleFotosActual++;
                    [self iteraBucleUploadFoto: id_pas_afegit];
                    
                }
                
            }else{
                
                self.iBucleFotosActual++;
                [self iteraBucleUploadFoto: id_pas_afegit];
                
            }
            
        });
        
    });
    
}

#pragma mark QuickLook data source

- (id)previewController:(QLPreviewController *)previewController previewItemAtIndex:(NSInteger)index
{
    
    return self.aTempDocumentURL[index];
    
}

- (NSInteger)numberOfPreviewItemsInPreviewController:(QLPreviewController *)controller
{
    
    return self.aTempDocumentURL.count;
    
}

#pragma mark Delegate i Respomder Collection View

- (CGFloat)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout*)collectionViewLayout minimumInteritemSpacingForSectionAtIndex:(NSInteger)section {
    
    return 0.0;
    
}

- (CGFloat)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout*)collectionViewLayout minimumLineSpacingForSectionAtIndex:(NSInteger)section {
    
    return 0.0;
    
}

- (UIEdgeInsets)collectionView:
(UICollectionView *)collectionView layout:(UICollectionViewLayout*)collectionViewLayout insetForSectionAtIndex:(NSInteger)section {
    
    return UIEdgeInsetsMake(0,0,0,0);  // top, left, bottom, right
    
}

- (NSInteger)collectionView:(UICollectionView *)collectionView numberOfItemsInSection:(NSInteger)section
{
    
    if(self.aParaulesCollectionView == nil)return 0;
    return self.aParaulesCollectionView.count;
    
}

- (void)collectionView:(UICollectionView *)collectionView didSelectItemAtIndexPath:(nonnull NSIndexPath *)indexPath
{

    if([self.textview_predicció isFirstResponder])[self.textview_predicció resignFirstResponder];
    
    if(self.iBlocPrediccioActual == 6)
    {
        if(indexPath.row == 0)
        {
            
            // final
            self.textview_predicció.text = [self.textview_predicció.text stringByAppendingString:@"."];
            self.bJaEmFetConjuncioFinal = false;
            
        }else{
            
            // i...
            
            self.textview_predicció.text = [self.textview_predicció.text stringByAppendingString:@" i"];

        }
        
        [self reiniciaPredictiuEnFuncioTextView];
        
        return;
        
    }
    
    NSString *paraula = (self.iBlocPrediccioActual == 1 ||
                         self.iBlocPrediccioActual == 3 ||
                         self.iBlocPrediccioActual == 4  ||
                         self.iBlocPrediccioActual == 5) ? self.aParaulesRealsCollectionView[indexPath.row] :
                                                         self.aParaulesCollectionView[indexPath.row];
    
    // +
    
    if((self.iBlocPrediccioActual == 1) && (indexPath.row == self.oViewControllerRecepta.aInstancies_ingredients.count))
    {
        
        UIAlertController *alert= [UIAlertController
                                   alertControllerWithTitle:@"Ingredient"
                                   message:@"Indica el nom de l'ingredient (amb l'article):"
                                   preferredStyle:UIAlertControllerStyleAlert];
        
        UIAlertAction* ok = [UIAlertAction actionWithTitle:@"D'acord" style:UIAlertActionStyleDefault
                                                   handler:^(UIAlertAction * action){
            
            [alert dismissViewControllerAnimated:YES completion:nil];
            
            UITextField *textField = alert.textFields[0];
            
            if([textField.text isEqualToString:@""])return;
            
            [self didSelectItemAtIndexPath2:textField.text indexPath:indexPath bIngredientAuxiliar:true];
            
        }];
        
        UIAlertAction* cancel = [UIAlertAction actionWithTitle:@"Cancel·la" style:UIAlertActionStyleDefault
                                                       handler:^(UIAlertAction * action) {
            
            [alert dismissViewControllerAnimated:YES completion:nil];
            
        }];
        
        alert.view.tintColor = UIColorFromRGB(PALETA_COLOR_VERMELL);
        
        [alert addAction:ok];
        [alert addAction:cancel];
        
        [alert addTextFieldWithConfigurationHandler:^(UITextField *textField) {
            textField.keyboardType = UIKeyboardTypeDefault;
        }];
        
        [self presentViewController:alert animated:YES completion:nil];
        
    }else{
        
        [self didSelectItemAtIndexPath2:paraula indexPath:indexPath bIngredientAuxiliar:false];
        
    }
    
    // fi +
    
}

-(void)didSelectItemAtIndexPath2:(NSString*)paraula indexPath:(nonnull NSIndexPath *)indexPath bIngredientAuxiliar:(bool)bIngredientAuxiliar
{
    
    if((self.iBlocPrediccioActual == 1) && self.bHemAfegitIngredient)
    {
        
        // RESOLDRE NEXE ENTRE INGREDIENTS
        
        paraula = [NSString stringWithFormat:@"i %@",paraula];
        
    }
    
    if([self.textview_predicció esModePlaceholder])
    {
        [self.textview_predicció setModeNormal];
        self.textview_predicció.text = @"";
    }
    
    bool bTextViewAcabaEnEspaiEnBlanc = (![self.textview_predicció.text isEqualToString:@""]) &&
                                        ([[self.textview_predicció.text substringFromIndex:self.textview_predicció.text.length-1]
                                        isEqualToString:@" "]);
    
    bool bTextViewEsBuit = [self.textview_predicció.text isEqualToString:@""];
    
    self.textview_predicció.text = [self.textview_predicció.text stringByAppendingString:[NSString stringWithFormat:@"%@%@",bTextViewAcabaEnEspaiEnBlanc || bTextViewEsBuit ? @"" : @" ",paraula]];
    
    if((self.iBlocPrediccioActual == 1) && self.bHemAfegitIngredient)
    {
        
        // RESOLDRE NEXE ENTRE INGREDIENTS
        
        if(self.rangDarreraIIngredient.length != 0)self.textview_predicció.text = [self.textview_predicció.text stringByReplacingCharactersInRange:self.rangDarreraIIngredient withString:@","];
        
        self.rangDarreraIIngredient = NSMakeRange(self.textview_predicció.text.length - paraula.length - 1, 2);
        
    }
    
    if(self.textview_predicció.text.length > 0 ) {
       NSRange bottom = NSMakeRange(self.textview_predicció.text.length -1, 1);
       [self.textview_predicció scrollRangeToVisible:bottom];
    }
    
    if(self.iBlocPrediccioActual == 0)
    {
        
        [self carregaBlocPredictiu:1];
        
        return;
        
    }
    
    if((self.iBlocPrediccioActual == 1) && bIngredientAuxiliar)
    {
        
        self.bHemAfegitIngredient = true;
        
    }
    
    if((self.iBlocPrediccioActual == 1) && !bIngredientAuxiliar)
    {
        
        self.iBlocPrediccioActual++;
        
        // Passem d'ingredient a selecció d'estat
        
        self.bHemAfegitIngredient = true;
        
        int iIndexIngredientSeleccionat = (int)indexPath.row;
        NSDictionary *dictIngredientSeleccionat = self.oViewControllerRecepta.aInstancies_ingredients[iIndexIngredientSeleccionat];
        
        self.label_capçalera_predictiu.text = self.aPrediccio[self.iBlocPrediccioActual][@"titol"];
        self.botoSeguentBlocPredictiu.hidden = NO;
        self.aParaulesCollectionView = [[NSMutableArray alloc] init];
        for (NSArray *aEstats in self.aPrediccio[self.iBlocPrediccioActual][@"valors"]) {
            
            NSString *sGenere = dictIngredientSeleccionat[@"genere"];
            
            bool bEsPlural = [IncludesCompartits ingredientEsPlural:dictIngredientSeleccionat[@"utilitza_unitat"]                                                                                    nom_singular:dictIngredientSeleccionat[@"nom_singular"]
                                                         nom_plural:dictIngredientSeleccionat[@"nom_plural"] quantitat:dictIngredientSeleccionat[@"quantitat"]];
            
            NSString *sEstat;
            
            if([sGenere isEqualToString:@"M"] && !bEsPlural)sEstat = aEstats[0];
            if([sGenere isEqualToString:@"F"] && !bEsPlural)sEstat = aEstats[1];
            if([sGenere isEqualToString:@"M"] && bEsPlural)sEstat = aEstats[2];
            if([sGenere isEqualToString:@"F"] && bEsPlural)sEstat = aEstats[3];
            
            [self.aParaulesCollectionView addObject:sEstat];
            
        }
        
        [self.collectionview reloadData];
        
        return;
        
    }
    
    if(self.iBlocPrediccioActual == 2)
    {
        
        [self carregaBlocPredictiu:1];
        
        return;
        
    }
    
    if(self.iBlocPrediccioActual == 3)
    {
        
        self.id_estri_escollit = [[self.aInstancies_estris[indexPath.row] valueForKey:@"id"] intValue];
        
        [self carregaBlocPredictiu:4];
        
        return;
        
    }
    
    if(self.iBlocPrediccioActual == 4)
    {
        
        if(self.id_estri_escollit != -1)
        {
            
            NSMutableArray *aIdsEstrisPrefereixenGraus = [[NSMutableArray alloc] init];
            if([IncludesCompartits carregaPreferenciaArray:@"ids_estris_potencia_graus"] != nil)aIdsEstrisPrefereixenGraus = [[NSMutableArray alloc] initWithArray:[IncludesCompartits carregaPreferenciaArray:@"ids_estris_potencia_graus"]];
            
            if([paraula rangeOfString:@"°"].location == NSNotFound)
            {
                // em escollit vitro, cal eliminar id_estri de la llista (si hi és)
                if ([aIdsEstrisPrefereixenGraus containsObject:[NSString stringWithFormat:@"%i",self.id_estri_escollit]]) {
                    [aIdsEstrisPrefereixenGraus removeObject:[NSString stringWithFormat:@"%i",self.id_estri_escollit]];
                }
            }else{
                // em escollit forn, cal afegir id_estri de la llista (si no hi és)
                if (![aIdsEstrisPrefereixenGraus containsObject:[NSString stringWithFormat:@"%i",self.id_estri_escollit]]) {
                    [aIdsEstrisPrefereixenGraus addObject:[NSString stringWithFormat:@"%i",self.id_estri_escollit]];
                }
            }
            
            [IncludesCompartits gravaPreferenciaArray:@"ids_estris_potencia_graus" valor:aIdsEstrisPrefereixenGraus];
            
            // TEST:
            
            /*
            NSMutableArray *aIdsEstrisPrefereixenGraus_LOADED = [[NSMutableArray alloc] initWithArray:[IncludesCompartits carregaPreferenciaArray:@"ids_estris_potencia_graus"]];
            NSLog(@"aIdsEstrisPrefereixenGraus_LOADED = %@", aIdsEstrisPrefereixenGraus_LOADED);
            */
            
        }
        
        [self carregaBlocPredictiu:5];
        
        return;
        
    }
    
    if(self.iBlocPrediccioActual == 5)
    {
        
        [self carregaBlocPredictiu:6];
        
        return;
        
    }
    
}
 
- (void)scrollViewWillBeginDragging:(UIScrollView *)scrollView
{
    
    if(scrollView == self.scrollview)
    {
        if([self.textview_predicció isFirstResponder])[self.textview_predicció resignFirstResponder];
    }

}

- (void)carregaBlocPredictiu:(int)iNumBloc
{
    
    if(iNumBloc == 1)
    {
        
        self.iBlocPrediccioActual = 1;
        
        // Passem d'acció a selecció ingredient
        
        self.label_capçalera_predictiu.text = self.aPrediccio[self.iBlocPrediccioActual][@"titol"];
        self.botoSeguentBlocPredictiu.hidden = NO;
        self.aParaulesCollectionView = [[NSMutableArray alloc] init];
        self.aParaulesRealsCollectionView = [[NSMutableArray alloc] init];
        
        for (NSDictionary *dictIngredient in self.oViewControllerRecepta.aInstancies_ingredients) {
            
            NSString *ingredientAReceptaAmbArticle = [IncludesCompartits retornaIngredientAReceptaAmbArticle:dictIngredient[@"utilitza_unitat"]
                                                                                                nom_singular:dictIngredient[@"nom_singular"]
                                                                                                  nom_plural:dictIngredient[@"nom_plural"]
                                                                                                   quantitat:dictIngredient[@"quantitat"]
                                                                                                      genere:dictIngredient[@"genere"]];
            
            [self.aParaulesRealsCollectionView addObject:ingredientAReceptaAmbArticle];
            [self.aParaulesCollectionView addObject:[IncludesCompartits converteixAMinusculaLaPrimeraLletra:([dictIngredient[@"nom_singular"] isEqualToString:@""]) ? dictIngredient[@"nom_plural"] : dictIngredient[@"nom_singular"]]];
            
        }
        
        [self.aParaulesRealsCollectionView addObject:@"+"];
        [self.aParaulesCollectionView addObject:@"+"];

        [self.collectionview reloadData];
        
    }
    
    if(iNumBloc == 3)
    {
        
        self.iBlocPrediccioActual = 3;
        
        // Passem a seleccionar els estris
        
        self.label_capçalera_predictiu.text = self.aPrediccio[self.iBlocPrediccioActual][@"titol"];
        self.botoSeguentBlocPredictiu.hidden = NO;
        self.aParaulesCollectionView = [[NSMutableArray alloc] init];
        self.aParaulesRealsCollectionView = [[NSMutableArray alloc] init];
        for (NSDictionary *dictEstri in self.aInstancies_estris) {
            
            NSString *estriAmbArticle = [IncludesCompartits retornaParaulaAmbAAl:dictEstri[@"genere"] numero:@"S" paraula:dictEstri[@"nom"]];
            estriAmbArticle = [[estriAmbArticle componentsSeparatedByString:@"("][0] stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]];
            [self.aParaulesRealsCollectionView addObject:estriAmbArticle];

            [self.aParaulesCollectionView addObject:[IncludesCompartits converteixAMinusculaLaPrimeraLletra:[[dictEstri[@"nom"] componentsSeparatedByString:@"("][0] stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]]]];
            
        }

        [self.collectionview reloadData];
        
    }
    
    if(iNumBloc == 4)
    {
        
        self.iBlocPrediccioActual = 4;
        
        // Passem a seleccionar la potència
        
        self.label_capçalera_predictiu.text = self.aPrediccio[self.iBlocPrediccioActual][@"titol"];
        self.botoSeguentBlocPredictiu.hidden = NO;
        self.aParaulesCollectionView = [[NSMutableArray alloc] init];
        self.aParaulesRealsCollectionView = [[NSMutableArray alloc] init];
        
        NSArray *aValorsForn = self.aPrediccio[self.iBlocPrediccioActual][@"valors"][0];
        NSArray *aValorsVitro = self.aPrediccio[self.iBlocPrediccioActual][@"valors"][1];
        
        NSArray *aPotenciesPrimer = aValorsVitro;
        NSArray *aPotenciesSegon = aValorsForn;
        
        // Preferència per graus
        NSArray *aIdsEstrisPrefereixenGraus = [IncludesCompartits carregaPreferenciaArray:@"ids_estris_potencia_graus"];
        if((aIdsEstrisPrefereixenGraus != nil) && ([aIdsEstrisPrefereixenGraus containsObject:[NSString stringWithFormat:@"%i",self.id_estri_escollit]]))
        {
            aPotenciesPrimer = aValorsForn;
            aPotenciesSegon = aValorsVitro;
        }
        
        for (NSString *sValor in aPotenciesPrimer)[self.aParaulesRealsCollectionView addObject:[NSString stringWithFormat:@"a %@", sValor]];
        for (NSString *sValor in aPotenciesSegon)[self.aParaulesRealsCollectionView addObject:[NSString stringWithFormat:@"a %@", sValor]];

        for (NSString *sValor in aPotenciesPrimer)[self.aParaulesCollectionView addObject:sValor];
        for (NSString *sValor in aPotenciesSegon)[self.aParaulesCollectionView addObject:sValor];
        
        [self.collectionview reloadData];
        
    }
    
    if(iNumBloc == 5)
    {
        
        self.iBlocPrediccioActual = 5;
        
        // Passem a seleccionar el temps
        
        self.label_capçalera_predictiu.text = self.aPrediccio[self.iBlocPrediccioActual][@"titol"];
        self.botoSeguentBlocPredictiu.hidden = NO;
        self.aParaulesCollectionView = [[NSMutableArray alloc] init];
        self.aParaulesRealsCollectionView = [[NSMutableArray alloc] init];
        
        NSArray *aValorsTemps = self.aPrediccio[self.iBlocPrediccioActual][@"valors"];
        
        for (NSString *sValor in aValorsTemps)[self.aParaulesRealsCollectionView addObject:[NSString stringWithFormat:@"durant %@", sValor]];
        for (NSString *sValor in aValorsTemps)[self.aParaulesCollectionView addObject:sValor];
        
        [self.collectionview reloadData];
        
    }
    
    if(iNumBloc == 6)
    {
        
        self.iBlocPrediccioActual = 6;
        
        // Passem a seleccionar el final
        
        self.label_capçalera_predictiu.text = @"FINAL";
        self.botoSeguentBlocPredictiu.hidden = YES;
        self.aParaulesCollectionView = [[NSMutableArray alloc] init];
        [self.aParaulesCollectionView addObject:@". (final)"];
        if(!self.bJaEmFetConjuncioFinal)[self.aParaulesCollectionView addObject:@"i (continuar)"];
        [self.collectionview reloadData];
        
        self.bJaEmFetConjuncioFinal = true;
        
    }

}

- (IBAction)clickSeguentBlocPredictiu:(id)sender {
    
    if(self.iBlocPrediccioActual == 1)
    {
        
        [self carregaBlocPredictiu:3];
        
        return;
        
    }
    
    if(self.iBlocPrediccioActual == 2)
    {
        
        [self carregaBlocPredictiu:1];
        
        return;
        
    }
    
    if(self.iBlocPrediccioActual == 3)
    {
        
        [self carregaBlocPredictiu:4];
        
        return;
        
    }
    
    if(self.iBlocPrediccioActual == 4)
    {
        
        [self carregaBlocPredictiu:5];
        
        return;
        
    }
    
    if(self.iBlocPrediccioActual == 5)
    {
        
        [self carregaBlocPredictiu:6];
        
        return;
        
    }
    
}

- (UICollectionViewCell *)collectionView:(UICollectionView *)collectionView cellForItemAtIndexPath:(NSIndexPath *)indexPath
{
    
    CollectionViewCellPredictiu *cell = [collectionView dequeueReusableCellWithReuseIdentifier:@"CollectionViewCellPredictiu" forIndexPath:indexPath];
    
    NSString *paraula = self.aParaulesCollectionView[indexPath.row];

    cell.label_titol.text = paraula;

    return cell;
    
}

@end
