//
//  ViewControllerQuantitatIngredientARecepta.m
//  ataula
//
//  Created by Andreu Biosca on 08/04/2020.
//  Copyright © 2020 EGDBE. All rights reserved.
//

#import "ViewControllerQuantitatIngredientARecepta.h"
#import "IncludesCompartits.h"
#import "ViewControllerAfegirIngredientRecepta.h"
#import "ViewControllerRecepta.h"

@interface ViewControllerQuantitatIngredientARecepta ()

@end

@implementation ViewControllerQuantitatIngredientARecepta

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    
    self.vistaArrodonida.layer.masksToBounds = true;
    self.vistaArrodonida.layer.cornerRadius = 15;
    self.vistaArrodonida.layer.borderWidth = .5;
    self.vistaArrodonida.layer.borderColor = UIColorFromRGB(0x888888).CGColor;
    
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(keyboardWillShow:) name:UIKeyboardWillShowNotification object:nil];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(keyboardWillHide:) name:UIKeyboardWillHideNotification object:nil];
    
    self.labelTitolQuantitat.text = [NSString stringWithFormat:@"Indica la quantitat %@ que vols afegir a la recepta:", self.ingredientAmbPreposicio];
    
    [self.boto_mig setTitle:[self.genere isEqualToString:@"M"] ? @"Mig" : @"Mitja" forState:UIControlStateNormal];
    
}

- (IBAction)afegirIngredient:(id)sender {
    
    if([self.textfield_quantitat.text isEqualToString:@""])return;
    
    [self afegirIngredientAReceptaPerNumero:[[self.textfield_quantitat.text stringByReplacingOccurrencesOfString:@"," withString:@"."] doubleValue]];
    
}

- (IBAction)clickOctau:(id)sender {
    
    [self afegirIngredientAReceptaPerNumero:0.125];
    
}

- (IBAction)clickQuart:(id)sender {
    
    [self afegirIngredientAReceptaPerNumero:0.25];
    
}

- (IBAction)clickMig:(id)sender {
    
    [self afegirIngredientAReceptaPerNumero:0.5];
    
}

- (IBAction)click3:(id)sender {
    
    [self afegirIngredientAReceptaPerNumero:3];
    
}

- (IBAction)click1:(id)sender {
    
    [self afegirIngredientAReceptaPerNumero:1];
    
}

- (IBAction)click2:(id)sender {
    
    [self afegirIngredientAReceptaPerNumero:2];
    
}

- (IBAction)click6:(id)sender {
    
    [self afegirIngredientAReceptaPerNumero:6];
    
}

- (IBAction)click12:(id)sender {
    
    [self afegirIngredientAReceptaPerNumero:12];
    
}

-(void)afegirIngredientAReceptaPerNumero:(double)dQuantitat
{
    
    NSString * sQuantitat = [IncludesCompartits formataADoble:[NSString stringWithFormat:@"%f",dQuantitat]];
    
    if([sQuantitat isEqualToString:@"0"] || (sQuantitat.doubleValue < 0))
    {
        [self presentViewController:[IncludesCompartits creaAlerta:@"Error" descripcio:@"Quantitat invàlida."] animated:YES completion:nil];
        return;
    }
    
    for (UIView *subview in self.boto_mig.superview.subviews)if([NSStringFromClass(subview.class) isEqualToString:@"UIButton"])((UIButton*)subview).enabled = NO;
    
    AFHTTPSessionManager *manager = [[AFHTTPSessionManager alloc]initWithSessionConfiguration:[NSURLSessionConfiguration defaultSessionConfiguration]];
    [manager.requestSerializer setValue:@"application/x-www-form-urlencoded; charset=UTF-8" forHTTPHeaderField:@"Content-Type"];
    
    NSString *URL_WS = [NSString stringWithFormat:@"%@/API/afegirIngredientARecepta",WS_HOST];
    
    NSDictionary *parameters = @{
        @"id_ingredient": self.oViewControllerAfegirIngredientRecepta.dictIngredientSeleccionat[@"id"],
        @"id_recepta": self.oViewControllerAfegirIngredientRecepta.oViewControllerRecepta.idRecepta,
        @"quantitat": sQuantitat,
        @"utilitza_unitat": @"0"
    };
    
    [manager POST:URL_WS parameters:parameters headers:nil progress:nil success:^(NSURLSessionDataTask * _Nonnull task, id  _Nullable responseObject) {
        
        // OK
        
        NSDictionary *json = responseObject;
        
        if([json[@"result"] intValue] == 1)
        {
            
            // KO
            
            [self presentViewController:[IncludesCompartits creaAlerta:@"Error" descripcio:json[@"error"]] animated:YES completion:nil];
            for (UIView *subview in self.boto_mig.superview.subviews)if([NSStringFromClass(subview.class) isEqualToString:@"UIButton"])((UIButton*)subview).enabled = YES;
            
        }else{
            
            [self dismissViewControllerAnimated:YES completion:^{
                
                [self.oViewControllerAfegirIngredientRecepta.oViewControllerRecepta refrescaIngredientsRecepta];
                [self.oViewControllerAfegirIngredientRecepta.navigationController popViewControllerAnimated:YES];
                
            }];
            
        }
        
    } failure:^(NSURLSessionDataTask * _Nullable task, NSError * _Nonnull error) {
        
        // KO
        
        for (UIView *subview in self.boto_mig.superview.subviews)if([NSStringFromClass(subview.class) isEqualToString:@"UIButton"])((UIButton*)subview).enabled = YES;
        [self presentViewController:[IncludesCompartits creaAlerta:@"Error" descripcio:@"Hi ha hagut un error de connexió."] animated:YES completion:nil];
        
    }];
    
}

- (IBAction)clickSortir:(id)sender {
    
    [self dismissViewControllerAnimated:YES completion:^{}];
    
}

-(void)keyboardWillShow:(NSNotification *)notification {
    
    if([[UIApplication sharedApplication] applicationState] != UIApplicationStateActive)return;
    
    CGRect keyboardRect = [[[notification userInfo] valueForKey:UIKeyboardFrameEndUserInfoKey] CGRectValue];
    CGRect rectActual = self.vistaContenedora.frame;
    rectActual.size.height = (self.view.frame.size.height) - (keyboardRect.size.height);
  
    // Animació
    
    [UIView animateWithDuration:[[[notification userInfo] valueForKey:UIKeyboardAnimationDurationUserInfoKey] floatValue]
                          delay:.02
                        options:[[[notification userInfo]
                                 valueForKey:UIKeyboardAnimationCurveUserInfoKey]intValue] animations:^{
        [self.vistaContenedora setFrame:rectActual];
    } completion:^(BOOL finished) {
        
    }];
    
}

-(void)keyboardWillHide:(NSNotification *)notification {
    
    if([[UIApplication sharedApplication] applicationState] != UIApplicationStateActive)return;
    
    CGRect rectActual = self.vistaContenedora.frame;
    rectActual.size.height = self.view.frame.size.height;

    // Animació
    
    [UIView animateWithDuration:[[[notification userInfo] valueForKey:UIKeyboardAnimationDurationUserInfoKey] floatValue]
                          delay:.02
                        options:[[[notification userInfo]
                                 valueForKey:UIKeyboardAnimationCurveUserInfoKey]intValue] animations:^{
        [self.vistaContenedora setFrame:rectActual];
    } completion:^(BOOL finished) {
        
    }];
    
}

@end
