//
//  ataulaTests.m
//  ataulaTests
//
//  Created by Andreu Biosca on 02/04/2020.
//  Copyright © 2020 EGDBE. All rights reserved.
//

// Ajuda unit testing amb Obj-C: https://www.objc.io/issues/15-testing/xctest/

#import <XCTest/XCTest.h>
#import "IncludesCompartits.h"

@interface ataulaTests : XCTestCase

@end

@implementation ataulaTests

- (void)setUp {
    // Put setup code here. This method is called before the invocation of each test method in the class.
    [super setUp];
}

- (void)tearDown {
    // Put teardown code here. This method is called after the invocation of each test method in the class.
    [super tearDown];
}

// Each method that has a name starting with test is a test.
// If we ever need to disable a test, we simply prefix the name with DISABLED

- (void)testIngredientAmbArticle {
    // This is an example of a functional test case.
    // Use XCTAssert and related functions to verify your tests produce the correct results.
    
    // given
    NSString *paraula_M_S_C = @"pebrot verd"; // masculí - singular - consonant
    NSString *paraula_M_P_C = @"pebrots verds"; // masculí - plural - consonant
    NSString *paraula_M_S_V = @"ou"; // masculí - singular - vocal
    NSString *paraula_M_P_V = @"ous"; // masculí - plural - vocal
    NSString *paraula_F_S_C = @"poma"; // femení - singular - consonant
    NSString *paraula_F_P_C = @"pomes"; // femení - plural - consonant
    NSString *paraula_F_S_V = @"albergínia"; // femení - singular - vocal
    NSString *paraula_F_P_V = @"albergínies"; // femení - plural - vocal
    
    // when
    NSString *M_S_C_article = [IncludesCompartits retornaParaulaAmbArticle:@"M" numero:@"S" paraula:paraula_M_S_C];
    NSString *M_P_C_article = [IncludesCompartits retornaParaulaAmbArticle:@"M" numero:@"P" paraula:paraula_M_P_C];
    NSString *M_S_V_article = [IncludesCompartits retornaParaulaAmbArticle:@"M" numero:@"S" paraula:paraula_M_S_V];
    NSString *M_P_V_article = [IncludesCompartits retornaParaulaAmbArticle:@"M" numero:@"P" paraula:paraula_M_P_V];
    NSString *F_S_C_article = [IncludesCompartits retornaParaulaAmbArticle:@"F" numero:@"S" paraula:paraula_F_S_C];
    NSString *F_P_C_article = [IncludesCompartits retornaParaulaAmbArticle:@"F" numero:@"P" paraula:paraula_F_P_C];
    NSString *F_S_V_article = [IncludesCompartits retornaParaulaAmbArticle:@"F" numero:@"S" paraula:paraula_F_S_V];
    NSString *F_P_V_article = [IncludesCompartits retornaParaulaAmbArticle:@"F" numero:@"P" paraula:paraula_F_P_V];
    
    // then
    XCTAssertEqualObjects(M_S_C_article, @"el pebrot verd");
    XCTAssertEqualObjects(M_P_C_article, @"els pebrots verds");
    XCTAssertEqualObjects(M_S_V_article, @"l'ou");
    XCTAssertEqualObjects(M_P_V_article, @"els ous");
    XCTAssertEqualObjects(F_S_C_article, @"la poma");
    XCTAssertEqualObjects(F_P_C_article, @"les pomes");
    XCTAssertEqualObjects(F_S_V_article, @"l'albergínia");
    XCTAssertEqualObjects(F_P_V_article, @"les albergínies");
    
}

- (void)testConverteixAMinusculaLaPrimeraLletra {
    // This is an example of a functional test case.
    // Use XCTAssert and related functions to verify your tests produce the correct results.
    
    // given
    NSString *paraula_1 = @"Pebrot verd";
    NSString *paraula_2 = @"pebrot verd";
    NSString *paraula_3 = @"Oliva";
    NSString *paraula_4 = @"oliva";
    NSString *paraula_5 = @"Olives negres d'Aragó";
    NSString *paraula_6 = @"olives negres d'Aragó";
    
    // when
    NSString *paraula_1_minus = [IncludesCompartits converteixAMinusculaLaPrimeraLletra:paraula_1];
    NSString *paraula_2_minus = [IncludesCompartits converteixAMinusculaLaPrimeraLletra:paraula_2];
    NSString *paraula_3_minus = [IncludesCompartits converteixAMinusculaLaPrimeraLletra:paraula_3];
    NSString *paraula_4_minus = [IncludesCompartits converteixAMinusculaLaPrimeraLletra:paraula_4];
    NSString *paraula_5_minus = [IncludesCompartits converteixAMinusculaLaPrimeraLletra:paraula_5];
    NSString *paraula_6_minus = [IncludesCompartits converteixAMinusculaLaPrimeraLletra:paraula_6];
    
    // then
    XCTAssertEqualObjects(paraula_1_minus, @"pebrot verd");
    XCTAssertEqualObjects(paraula_2_minus, @"pebrot verd");
    XCTAssertEqualObjects(paraula_3_minus, @"oliva");
    XCTAssertEqualObjects(paraula_4_minus, @"oliva");
    XCTAssertEqualObjects(paraula_5_minus, @"olives negres d'Aragó");
    XCTAssertEqualObjects(paraula_6_minus, @"olives negres d'Aragó");
    
}

- (void)testRetornaIngredientARecepta {
    // This is an example of a functional test case.
    // Use XCTAssert and related functions to verify your tests produce the correct results.
    
    // given / when
    
    NSString *paraula_M_SP_nQ_g_1 = [IncludesCompartits retornaIngredientARecepta:@"M" nom_singular:@"All" nom_plural:@"Alls" quantitat:@"0" unitat:@"g" utilitza_unitat:@"1"];
    NSString *paraula_M_SP_nQ_g_0 = [IncludesCompartits retornaIngredientARecepta:@"M" nom_singular:@"All" nom_plural:@"Alls" quantitat:@"0" unitat:@"g" utilitza_unitat:@"0"];
    NSString *paraula_M_SP_Q_g_1 = [IncludesCompartits retornaIngredientARecepta:@"M" nom_singular:@"Pebrot verd" nom_plural:@"Pebrots verds" quantitat:@"3" unitat:@"g" utilitza_unitat:@"1"];
    NSString *paraula_M_SP_Q_g_0 = [IncludesCompartits retornaIngredientARecepta:@"M" nom_singular:@"All" nom_plural:@"Alls" quantitat:@"12" unitat:@"g" utilitza_unitat:@"0"];
    NSString *paraula_M_SP_Q_g_0_ = [IncludesCompartits retornaIngredientARecepta:@"M" nom_singular:@"All" nom_plural:@"Alls" quantitat:@"13" unitat:@"g" utilitza_unitat:@"0"];
    NSString *paraula_M_SP_Q_g_0__ = [IncludesCompartits retornaIngredientARecepta:@"M" nom_singular:@"All" nom_plural:@"Alls" quantitat:@"1" unitat:@"g" utilitza_unitat:@"0"];
    
    NSString *paraula_M_S_nQ_g_1 = [IncludesCompartits retornaIngredientARecepta:@"M" nom_singular:@"Julivert" nom_plural:@"" quantitat:@"0" unitat:@"g" utilitza_unitat:@"1"];
    NSString *paraula_M_S_nQ_g_0 = [IncludesCompartits retornaIngredientARecepta:@"M" nom_singular:@"Julivert" nom_plural:@"" quantitat:@"0" unitat:@"g" utilitza_unitat:@"0"];
    NSString *paraula_M_S_Q_g_1 = [IncludesCompartits retornaIngredientARecepta:@"M" nom_singular:@"Julivert" nom_plural:@"" quantitat:@"3" unitat:@"g" utilitza_unitat:@"1"];
    NSString *paraula_M_S_Q_g_0 = [IncludesCompartits retornaIngredientARecepta:@"M" nom_singular:@"Julivert" nom_plural:@"" quantitat:@"12" unitat:@"g" utilitza_unitat:@"0"];
    NSString *paraula_M_S_Q_g_0_ = [IncludesCompartits retornaIngredientARecepta:@"M" nom_singular:@"Julivert" nom_plural:@"" quantitat:@"13" unitat:@"g" utilitza_unitat:@"0"];
    NSString *paraula_M_S_Q_g_0__ = [IncludesCompartits retornaIngredientARecepta:@"M" nom_singular:@"Julivert" nom_plural:@"" quantitat:@"1" unitat:@"g" utilitza_unitat:@"0"];
    NSString *paraula_M_S_Q_g_0___ = [IncludesCompartits retornaIngredientARecepta:@"M" nom_singular:@"Julivert" nom_plural:@"" quantitat:@"0.6" unitat:@"g" utilitza_unitat:@"0"];
    
    NSString *paraula_M_P_nQ_g_1 = [IncludesCompartits retornaIngredientARecepta:@"M" nom_singular:@"" nom_plural:@"Germinats" quantitat:@"0" unitat:@"g" utilitza_unitat:@"1"];
    NSString *paraula_M_P_nQ_g_0 = [IncludesCompartits retornaIngredientARecepta:@"M" nom_singular:@"" nom_plural:@"Germinats" quantitat:@"0" unitat:@"g" utilitza_unitat:@"0"];
    NSString *paraula_M_P_Q_g_1 = [IncludesCompartits retornaIngredientARecepta:@"M" nom_singular:@"" nom_plural:@"Germinats" quantitat:@"3" unitat:@"g" utilitza_unitat:@"1"];
    NSString *paraula_M_P_Q_g_0 = [IncludesCompartits retornaIngredientARecepta:@"M" nom_singular:@"" nom_plural:@"Germinats" quantitat:@"12" unitat:@"g" utilitza_unitat:@"0"];
    NSString *paraula_M_P_Q_g_0_ = [IncludesCompartits retornaIngredientARecepta:@"M" nom_singular:@"" nom_plural:@"Germinats" quantitat:@"13" unitat:@"g" utilitza_unitat:@"0"];
    NSString *paraula_M_P_Q_g_0__ = [IncludesCompartits retornaIngredientARecepta:@"M" nom_singular:@"" nom_plural:@"Germinats" quantitat:@"1" unitat:@"g" utilitza_unitat:@"0"];
    NSString *paraula_M_P_Q_g_0___ = [IncludesCompartits retornaIngredientARecepta:@"M" nom_singular:@"" nom_plural:@"Germinats" quantitat:@"0.6" unitat:@"g" utilitza_unitat:@"0"];
    
    NSString *paraula_F_SP_nQ_g_1 = [IncludesCompartits retornaIngredientARecepta:@"F" nom_singular:@"Albergínia" nom_plural:@"Albergínies" quantitat:@"0" unitat:@"g" utilitza_unitat:@"1"];
    NSString *paraula_F_SP_nQ_g_0 = [IncludesCompartits retornaIngredientARecepta:@"F" nom_singular:@"Albergínia" nom_plural:@"Albergínies" quantitat:@"0" unitat:@"g" utilitza_unitat:@"0"];
    NSString *paraula_F_SP_Q_g_1 = [IncludesCompartits retornaIngredientARecepta:@"F" nom_singular:@"Poma" nom_plural:@"Pomes" quantitat:@"3" unitat:@"g" utilitza_unitat:@"1"];
    NSString *paraula_F_SP_Q_g_0 = [IncludesCompartits retornaIngredientARecepta:@"F" nom_singular:@"Albergínia" nom_plural:@"Albergínies" quantitat:@"12" unitat:@"g" utilitza_unitat:@"0"];
    NSString *paraula_F_SP_Q_g_0_ = [IncludesCompartits retornaIngredientARecepta:@"F" nom_singular:@"Albergínia" nom_plural:@"Albergínies" quantitat:@"13" unitat:@"g" utilitza_unitat:@"0"];
    NSString *paraula_F_SP_Q_g_0__ = [IncludesCompartits retornaIngredientARecepta:@"F" nom_singular:@"Albergínia" nom_plural:@"Albergínies" quantitat:@"1" unitat:@"g" utilitza_unitat:@"0"];
    
    NSString *paraula_F_S_nQ_g_1 = [IncludesCompartits retornaIngredientARecepta:@"F" nom_singular:@"Mantega" nom_plural:@"" quantitat:@"0" unitat:@"g" utilitza_unitat:@"1"];
    NSString *paraula_F_S_nQ_g_0 = [IncludesCompartits retornaIngredientARecepta:@"F" nom_singular:@"Mantega" nom_plural:@"" quantitat:@"0" unitat:@"g" utilitza_unitat:@"0"];
    NSString *paraula_F_S_Q_g_1 = [IncludesCompartits retornaIngredientARecepta:@"F" nom_singular:@"Mantega" nom_plural:@"" quantitat:@"3" unitat:@"g" utilitza_unitat:@"1"];
    NSString *paraula_F_S_Q_g_0 = [IncludesCompartits retornaIngredientARecepta:@"F" nom_singular:@"Mantega" nom_plural:@"" quantitat:@"12" unitat:@"g" utilitza_unitat:@"0"];
    NSString *paraula_F_S_Q_g_0_ = [IncludesCompartits retornaIngredientARecepta:@"F" nom_singular:@"Mantega" nom_plural:@"" quantitat:@"13" unitat:@"g" utilitza_unitat:@"0"];
    NSString *paraula_F_S_Q_g_0__ = [IncludesCompartits retornaIngredientARecepta:@"F" nom_singular:@"Mantega" nom_plural:@"" quantitat:@"1" unitat:@"g" utilitza_unitat:@"0"];
    NSString *paraula_F_S_Q_g_0___ = [IncludesCompartits retornaIngredientARecepta:@"F" nom_singular:@"Mantega" nom_plural:@"" quantitat:@"0.6" unitat:@"g" utilitza_unitat:@"0"];
    
    NSString *paraula_F_P_nQ_g_1 = [IncludesCompartits retornaIngredientARecepta:@"F" nom_singular:@"" nom_plural:@"Llenties" quantitat:@"0" unitat:@"g" utilitza_unitat:@"1"];
    NSString *paraula_F_P_nQ_g_0 = [IncludesCompartits retornaIngredientARecepta:@"F" nom_singular:@"" nom_plural:@"Llenties" quantitat:@"0" unitat:@"g" utilitza_unitat:@"0"];
    NSString *paraula_F_P_Q_g_1 = [IncludesCompartits retornaIngredientARecepta:@"F" nom_singular:@"" nom_plural:@"Llenties" quantitat:@"3" unitat:@"g" utilitza_unitat:@"1"];
    NSString *paraula_F_P_Q_g_0 = [IncludesCompartits retornaIngredientARecepta:@"F" nom_singular:@"" nom_plural:@"Llenties" quantitat:@"12" unitat:@"g" utilitza_unitat:@"0"];
    NSString *paraula_F_P_Q_g_0_ = [IncludesCompartits retornaIngredientARecepta:@"F" nom_singular:@"" nom_plural:@"Llenties" quantitat:@"13" unitat:@"g" utilitza_unitat:@"0"];
    NSString *paraula_F_P_Q_g_0__ = [IncludesCompartits retornaIngredientARecepta:@"F" nom_singular:@"" nom_plural:@"Llenties" quantitat:@"1" unitat:@"g" utilitza_unitat:@"0"];
    NSString *paraula_F_P_Q_g_0___ = [IncludesCompartits retornaIngredientARecepta:@"F" nom_singular:@"" nom_plural:@"Llenties" quantitat:@"0.6" unitat:@"g" utilitza_unitat:@"0"];
    
    // then
    
    XCTAssertEqualObjects(paraula_M_SP_nQ_g_1, @"0 g d'all"); // Per interfície gràfica no permés
    XCTAssertEqualObjects(paraula_M_SP_nQ_g_0, @"All");
    XCTAssertEqualObjects(paraula_M_SP_Q_g_1, @"3 g de pebrot verd");
    XCTAssertEqualObjects(paraula_M_SP_Q_g_0, @"Una dotzena d'alls");
    XCTAssertEqualObjects(paraula_M_SP_Q_g_0_, @"13 alls");
    XCTAssertEqualObjects(paraula_M_SP_Q_g_0__, @"1 all");
    
    XCTAssertEqualObjects(paraula_M_S_nQ_g_1, @"0 g de julivert"); // Per interfície gràfica no permés
    XCTAssertEqualObjects(paraula_M_S_nQ_g_0, @"Julivert");
    XCTAssertEqualObjects(paraula_M_S_Q_g_1, @"3 g de julivert");
    XCTAssertEqualObjects(paraula_M_S_Q_g_0, @"Julivert"); // Per interfície gràfica no permés
    XCTAssertEqualObjects(paraula_M_S_Q_g_0_, @"Julivert"); // Per interfície gràfica no permés
    XCTAssertEqualObjects(paraula_M_S_Q_g_0__, @"Julivert"); // Per interfície gràfica no permés
    XCTAssertEqualObjects(paraula_M_S_Q_g_0___, @"Julivert"); // Per interfície gràfica no permés
    
    XCTAssertEqualObjects(paraula_M_P_nQ_g_1, @"0 g de germinats"); // Per interfície gràfica no permés
    XCTAssertEqualObjects(paraula_M_P_nQ_g_0, @"Germinats");
    XCTAssertEqualObjects(paraula_M_P_Q_g_1, @"3 g de germinats");
    XCTAssertEqualObjects(paraula_M_P_Q_g_0, @"Germinats"); // Per interfície gràfica no permés
    XCTAssertEqualObjects(paraula_M_P_Q_g_0_, @"Germinats"); // Per interfície gràfica no permés
    XCTAssertEqualObjects(paraula_M_P_Q_g_0__, @"Germinats"); // Per interfície gràfica no permés
    XCTAssertEqualObjects(paraula_M_P_Q_g_0___, @"Germinats"); // Per interfície gràfica no permés
    
    XCTAssertEqualObjects(paraula_F_SP_nQ_g_1, @"0 g d'albergínia"); // Per interfície gràfica no permés
    XCTAssertEqualObjects(paraula_F_SP_nQ_g_0, @"Albergínia");
    XCTAssertEqualObjects(paraula_F_SP_Q_g_1, @"3 g de poma");
    XCTAssertEqualObjects(paraula_F_SP_Q_g_0, @"Una dotzena d'albergínies");
    XCTAssertEqualObjects(paraula_F_SP_Q_g_0_, @"13 albergínies");
    XCTAssertEqualObjects(paraula_F_SP_Q_g_0__, @"1 albergínia");
    
    XCTAssertEqualObjects(paraula_F_S_nQ_g_1, @"0 g de mantega"); // Per interfície gràfica no permés
    XCTAssertEqualObjects(paraula_F_S_nQ_g_0, @"Mantega");
    XCTAssertEqualObjects(paraula_F_S_Q_g_1, @"3 g de mantega");
    XCTAssertEqualObjects(paraula_F_S_Q_g_0, @"Mantega"); // Per interfície gràfica no permés
    XCTAssertEqualObjects(paraula_F_S_Q_g_0_, @"Mantega"); // Per interfície gràfica no permés
    XCTAssertEqualObjects(paraula_F_S_Q_g_0__, @"Mantega"); // Per interfície gràfica no permés
    XCTAssertEqualObjects(paraula_F_S_Q_g_0___, @"Mantega"); // Per interfície gràfica no permés
    
    XCTAssertEqualObjects(paraula_F_P_nQ_g_1, @"0 g de llenties"); // Per interfície gràfica no permés
    XCTAssertEqualObjects(paraula_F_P_nQ_g_0, @"Llenties");
    XCTAssertEqualObjects(paraula_F_P_Q_g_1, @"3 g de llenties");
    XCTAssertEqualObjects(paraula_F_P_Q_g_0, @"Llenties"); // Per interfície gràfica no permés
    XCTAssertEqualObjects(paraula_F_P_Q_g_0_, @"Llenties"); // Per interfície gràfica no permés
    XCTAssertEqualObjects(paraula_F_P_Q_g_0__, @"Llenties"); // Per interfície gràfica no permés
    XCTAssertEqualObjects(paraula_F_P_Q_g_0___, @"Llenties"); // Per interfície gràfica no permés
    
}

@end
