function localitzaData(data_a_normalitzar) {
    var mesos = ["Gener", "Febrer",
        "Març", "Abril",
        "Maig", "Juny",
        "Juliol", "Agost",
        "Setembre", "Octubre",
        "Novembre", "Desembre"];

    if (data_a_normalitzar == "0000-00-00 00:00:00")
        return "?";

    return  data_a_normalitzar.substring(8, 10) + "-" + (data_a_normalitzar.substring(5, 7))
        + "-" + data_a_normalitzar.substring(0, 4);

}

function convertToSlug(Text)
{

    // remove accents, swap ñ for n, etc
    var from = "ãàáäâẽèéëêìíïîõòóöôùúüûñç·/_,:;";
    var to   = "aaaaaeeeeeiiiiooooouuuunc------";
    for (var i=0, l=from.length ; i<l ; i++) {
        Text = Text.replace(new RegExp(from.charAt(i), 'g'), to.charAt(i));
    }

    return Text
        .toLowerCase()
        .replace(/[^\w ]+/g,'')
        .replace(/ +/g,'-')
        ;
}

function converteixAMinusculaLaPrimeraLletra(paraula)
{

    return (paraula.substring(0, 1)).toLowerCase() + paraula.substring(1);

}

accentsTidy = function(s){
    var r=s.toLowerCase();
    r = r.replace(new RegExp(/\s/g),"");
    r = r.replace(new RegExp(/[àáâãäå]/g),"a");
    r = r.replace(new RegExp(/æ/g),"ae");
    r = r.replace(new RegExp(/ç/g),"c");
    r = r.replace(new RegExp(/[èéêë]/g),"e");
    r = r.replace(new RegExp(/[ìíîï]/g),"i");
    r = r.replace(new RegExp(/ñ/g),"n");
    r = r.replace(new RegExp(/[òóôõö]/g),"o");
    r = r.replace(new RegExp(/œ/g),"oe");
    r = r.replace(new RegExp(/[ùúûü]/g),"u");
    r = r.replace(new RegExp(/[ýÿ]/g),"y");
    r = r.replace(new RegExp(/\W/g),"");
    return r;
};

function retornaParaulaAmbPreposicio(paraula)
{

    var sPrimeraLletra = accentsTidy((paraula.substring(0, 1)).toLowerCase());

    var bComensaAmbVocal = (sPrimeraLletra == "a") ||
        (sPrimeraLletra == "e") ||
        (sPrimeraLletra == "i") ||
        (sPrimeraLletra == "o") ||
        (sPrimeraLletra == "u");

    return bComensaAmbVocal ? "d'" + converteixAMinusculaLaPrimeraLletra(paraula) :
        "de " + converteixAMinusculaLaPrimeraLletra(paraula);

}


function retornaIngredientARecepta(genere, nom_singular, nom_plural, quantitat, unitat, utilitza_unitat)
{

    if(nom_singular != "")
    {

        // Usem expressió singular

        if(utilitza_unitat == "1")
        {

            // Utilitza unitat

            return quantitat.replace('.', ',')  +
                " " +
                unitat +
                " " +
                retornaParaulaAmbPreposicio(converteixAMinusculaLaPrimeraLletra(nom_singular));

        }else{

            if(quantitat == "0"){

                return nom_singular;

            }else{

                var bEsPlural = parseFloat(quantitat) > 1;

                if((bEsPlural && nom_plural == "") ||
                    ((!bEsPlural) && nom_singular == "") ||
                    ((!bEsPlural) && nom_singular == "")){

                    return nom_singular;

                }

                if(quantitat == "0.125" ||
                    quantitat == "0.25" ||
                    quantitat == "6" ||
                    quantitat == "12" ||
                    quantitat == "24" ||
                    quantitat == "15"){

                    var sForma = "";

                    if(quantitat == "0.125")sForma = "Un octau";
                    if(quantitat == "0.25")sForma = "Un quart";
                    if(quantitat == "6")sForma = "Mitja dotzena";
                    if(quantitat == "12")sForma = "Una dotzena";
                    if(quantitat == "24")sForma = "Dos dotzenes";
                    if(quantitat == "15")sForma = "Una quinzena";

                    return sForma + " " + retornaParaulaAmbPreposicio(converteixAMinusculaLaPrimeraLletra(bEsPlural ? nom_plural : nom_singular));

                }

                if(quantitat == "0.5"){

                    return genere == "M" ? "Mig" : "Mitja" + " " + converteixAMinusculaLaPrimeraLletra(nom_singular);

                }

                if(quantitat == "1.5"){

                    return (genere == "M" ? "Un" : "Una") + " " + converteixAMinusculaLaPrimeraLletra(nom_singular) + " i " + (genere == "M" ? "mig" : "mitja");

                }

                if(quantitat == "2.5"){

                    return "Dos " + converteixAMinusculaLaPrimeraLletra(nom_plural) + " i " + (genere == "M" ? "mig" : "mitja");

                }

                return quantitat.replace('.', ',') + " " + converteixAMinusculaLaPrimeraLletra(bEsPlural ? nom_plural : nom_singular);

            }

        }

    }else{

        // Usem expressió plural

        if(utilitza_unitat == "1")
        {

            // Utilitza unitat

            return quantitat.replace('.', ',') + " " + unitat + " " + retornaParaulaAmbPreposicio(converteixAMinusculaLaPrimeraLletra(nom_plural));

        }else{

            return nom_plural;

        }

    }

}
