<html>
<head>
    <title>ataula</title>
    <link rel="icon" type="image/png" sizes="96x96" href="/Media/favicon-96x96.png">
    <link rel="icon" type="image/png" sizes="32x32" href="/Media/favicon-32x32.png">
    <link rel="icon" type="image/png" sizes="16x16" href="/Media/favicon-16x16.png">
    <link href="https://fonts.googleapis.com/css?family=Work+Sans" rel="stylesheet">
    <link href="https://fonts.googleapis.com/css?family=Roboto:300" rel="stylesheet">
    <script src="/Media/jquery-3.3.1.min.js"></script>
    <?php $ara = new DateTime(); ?>
    <script src="/Media/funcions_comunes.js?nocache=<?=$ara->getTimestamp();?>"></script>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
    <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.6.1/css/all.css" integrity="sha384-gfdkjb5BdAXd+lj+gudLWI+BXq4IuLW5IT+brZEZsLFm++aCMlF1V92rMkPaX4PP" crossorigin="anonymous">
</head>
<script>

    var id_recepta = "<?=$_GET['id_recepta'];?>";

    $(document).ready(function() {

        // get recepta

        $.ajax({
            url: '/API/getRecepta',
            data: {id : id_recepta},
            type: "POST",
            dataType: 'json',
            success: function (data) {

                if (data.result == 0) {

                    var oRecepta = data.data;

                    var sURLfoto = oRecepta.foto == "" ? "/Media/placeholder_recepta.png" : oRecepta.foto;
                    var sTitol = oRecepta.titol == "" ? "Recepta " + localitzaData(oRecepta.data_creacio) : oRecepta.titol;

                    document.title = 'ataula :: ' + sTitol;

                    $("#img_capsalera_recepta").attr("src", sURLfoto);

                    $("#div_titol_recepta").html(sTitol);

                    if(oRecepta.temps || oRecepta.preu)
                    {
                        if(oRecepta.temps && oRecepta.preu)
                        {
                            $("#div_minuts_preu_recepta").html(oRecepta.temps + " minuts / " + oRecepta.preu + "€");
                        }else{
                            if(oRecepta.temps)
                            {
                                $("#div_minuts_preu_recepta").html(oRecepta.temps + " minuts");
                            }else{
                                $("#div_minuts_preu_recepta").html(oRecepta.preu + "€");
                            }
                        }
                        $("#div_minuts_preu_recepta").css("display", "block");
                    }

                    $.ajax({
                        url: '/API/getIngredientsRecepta',
                        data: {id_recepta : oRecepta.id},
                        type: "POST",
                        dataType: 'json',
                        success: function (data) {

                            if (data.result == 0) {

                                $.each(data.data, function (index, oIngredient) {

                                    $("#llista_ingredients").append("<div>• " + retornaIngredientARecepta(oIngredient.genere,
                                        oIngredient.nom_singular,
                                        oIngredient.nom_plural,
                                        oIngredient.quantitat,
                                        oIngredient.unitat,
                                        oIngredient.utilitza_unitat) + "</div>");

                                });

                            }

                        }

                    });

                    $.ajax({
                        url: '/API/getPassosRecepta',
                        data: {id_recepta : oRecepta.id},
                        type: "POST",
                        dataType: 'json',
                        success: function (data) {

                            if (data.result == 0) {

                                $.each(data.data, function (index, oPas) {

                                    $("#llista_passos").append("<div> <div class='pas'>" +
                                        "<div style='margin-top: 3px;'>"+oPas.numero+"</div></div>" + oPas.descripcio + "</div>");

                                    var sCodiFotos = "<div>";

                                    $.each(oPas.urls_fotos_adjuntes, function (index, url_foto_adjunta) {

                                        sCodiFotos += "<div style='display: inline-block;'>" +
                                            "<a target='_blank' href='"+url_foto_adjunta.replace('_thumb', '')+"'><img src='"+url_foto_adjunta+"'></a></div>";

                                    });

                                    sCodiFotos += "</div>";

                                    $("#llista_passos").append(sCodiFotos);

                                });

                            }

                        }

                    });


                }

            }

        });

    });

</script>

<style>

    #img_capsalera_recepta
    {
        object-fit: cover;
    }

    body
    {
        margin: 0px;
        padding: 0px;
        border: 0px;
        font-family: 'Roboto';
        background-image: url("/Media/craft-paper.jpg");
        background-repeat: repeat;
    }

    #llista_ingredients > div
    {

        padding-left: 20px;
        padding-top: 10px;

    }

    #llista_passos > div
    {

        padding-left: 20px;
        padding-top: 15px;

    }

    #llista_passos img
    {

        width: 100px;height: 50px;
        object-fit: cover;
        border-radius: 5px;
        margin-right: 15px;
        cursor: pointer;

    }

    #llista_passos
    {

        margin-bottom: 20px;

    }

    .titol_seccio
    {
        font-size: 25px;
        padding: 20px;
        font-weight: bold;
        padding-bottom: 0px;
    }

    #div_titol_recepta
    {
        float: left;
        z-index: 9999;
        position: absolute;
        margin-top: 20px;
        margin-left: 20px;
        font-size: 30px;
        font-weight: bold;
        background-color: rgba(0, 0, 0, 0.5);
        color: white;
        text-transform: uppercase;
        padding: 10px;
    }

    #div_minuts_preu_recepta
    {
        float: left;
        z-index: 9999;
        position: absolute;
        margin-top: 80px;
        margin-left: 20px;
        font-size: 18px;
        font-weight: bold;
        background-color: rgba(0, 0, 0, 0.5);
        color: white;
        text-transform: uppercase;
        padding: 10px;
        display: none;
    }

    .pas
    {
        display: inline-block;
        background-color: black;
        margin-right: 8px;
        color: white;
        width: 20px;
        height: 20px;
        border-radius: 10px;
        text-align: center;
        font-size: 12px;
        font-weight: bold;

    }
</style>

<body>

        <div style="width: 100%;height: 300px;background-color: #EEE;position: relative;">
            <img id="img_capsalera_recepta" style="width: 100%;height: 100%;position: absolute;">
            <div id="div_titol_recepta"></div>
            <div id="div_minuts_preu_recepta"></div>
        </div>

        <div class="titol_seccio" style="margin-bottom: 5px;">Ingredients</div>
        <div id="llista_ingredients"></div>

        <div class="titol_seccio" style="margin-top: 20px;">Passos</div>
        <div id="llista_passos"></div>

</body>
</html>