<?php
// Revisar si tenim sessió oberta
if (session_status() == PHP_SESSION_NONE)session_start();
if (!(isset($_SESSION) && isset($_SESSION["CONECTATS"]))) {
    require_once $_SERVER{'DOCUMENT_ROOT'} . '/login.php';
    die();
}
?>
<!DOCTYPE html>
<html>
<head>
    <title>ataula</title>
    <link rel="icon" type="image/png" sizes="96x96" href="/Media/favicon-96x96.png">
    <link rel="icon" type="image/png" sizes="32x32" href="/Media/favicon-32x32.png">
    <link rel="icon" type="image/png" sizes="16x16" href="/Media/favicon-16x16.png">
    <script src="/Media/jquery-3.3.1.min.js"></script>
    <script src="/Media/funcions_comunes.js"></script>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
    <link href="https://fonts.googleapis.com/css?family=Work+Sans" rel="stylesheet">
    <link href="https://fonts.googleapis.com/css?family=Roboto:300" rel="stylesheet">
    <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.6.1/css/all.css" integrity="sha384-gfdkjb5BdAXd+lj+gudLWI+BXq4IuLW5IT+brZEZsLFm++aCMlF1V92rMkPaX4PP" crossorigin="anonymous">
</head>
<body>
<style>
    body
    {
        margin: 0px;
        padding: 0px;
        border: 0px;
        font-family: 'Roboto';
    }
</style>

<script>

    function logout()
    {

        $.ajax({
            url: '/API/logout',
            data: {},
            dataType: 'json',
            success: function (data) {

                window.location.href = "/";

            }

        });

    }



    $(document).ready(function() {

        // llistat receptes

        $.ajax({
            url: '/API/cercaReceptes',
            type: "POST",
            data: {cerca : ""},
            dataType: 'json',
            success: function (data) {

                if (data.result == 0) {

                    $.each(data.data, function (index, oRecepta) {

                        var sTitol = oRecepta.titol == "" ? "Recepta " + localitzaData(oRecepta.data_creacio) : oRecepta.titol;
                        var sURLfoto = oRecepta.foto == "" ? "/Media/placeholder_recepta.png" : oRecepta.foto;

                        var sElementRecepta = '<div class="bloc_recepta"><table border="0" cellpadding="0" cellspacing="0" ' +
                            '                         onclick="carregaRecepta('+oRecepta.id+',\''+convertToSlug(sTitol)+'\')">' +
                            '                           <tr>' +
                            '                               <td><img class="img_recepta" src="'+sURLfoto+'" style="width: 50px; height: 50px;"></td>' +
                            '                               <td><div class="titol_recepta">'+sTitol+'</div></td>' +
                            '                           </tr>' +
                            '                   </table></div>';

                        $("#div_llistat").append(sElementRecepta);

                    });

                }

            }

        });

    });

    function carregaRecepta(id_recepta, slug_title)
    {

        var win = window.open('/recepta/'+id_recepta+"/"+slug_title, '_blank');
        if (win) {
            //Browser has allowed it to be opened
            win.focus();
        } else {
            //Browser has blocked it
            alert('Si et plau, activa els popups per aquesta pàgina.');
        }

    }

</script>

<style>

    .img_recepta
    {
        border-radius: 10px;
        object-fit: cover;
    }

    .titol_recepta
    {
        margin-left: 10px;
    }

    .bloc_recepta
    {
        padding: 10px;
        padding-left: 0px;
        cursor: pointer;
    }

    .bloc_recepta:hover
    {
        color: #E91615;
    }

    .bloc_recepta:first-child
    {
        padding-top: 0px;
    }

    #div_llistat
    {
        background-color: white;
        width: calc(100vw - 245px);
        height: calc(100vh - 40px);
        position: fixed;
        top: 20px;
        left: 225px;
        overflow-y: scroll;
    }

</style>

<img style="width: 220px;margin-top: 12px;" src="/Media/Logo.png">
<div style="cursor: pointer;color: gray;margin-left: 20px;margin-top: 10px;" onclick="logout();">
    <i class="fas fa-sign-out-alt"></i> <span style="text-decoration: underline;">tancar sessió</span>
</div>

<div id="div_llistat"></div>

</body>
</html>